c  Fichier mise_a_0_2D_c.f 
c
c*****************************************************************
      subroutine  MISE_A_ZERO_2D_c(bb1,bb2,jb1,jb2,aa1,aa2,
     @   ja1,ja2,K,SMinter1,SMinter2,nti1,nti2,
     @     nelemA1,nelemA2,nelemB1,nelemB2,
     @ poroh1,MOY1,poroh2,MOY2,aire1,aire2)
c*****************************************************************
c
c  Cette procedure initialise les tableaux bb,jb,aa,ja,SMinter
c  a zero, ainsi que la partie non diagonale du tenseur K.
c
      implicit none

      integer   i
      integer   nelemB1,nelemB2,jb1,jb2,ja1,ja2
      integer   nelemA1,nelemA2,nti1,nti2
      real*8    K,poroh1,poroh2,MOY1,MOY2
      real*8    SMinter1,SMinter2,aa1,aa2
      real*8    bb1,bb2,aire1,aire2        
      dimension K(2,*),MOY1(*),MOY2(*)
      dimension SMinter1(*),SMinter2(*)
      dimension aa1(*),aa2(*),ja1(*),ja2(*)
      dimension bb1(*),bb2(*),jb1(*),jb2(*)

      aire1=0.d0
      aire2=0.d0

      do i=1,nti1     
         SMinter1(i)=0.d0
      enddo
      do i=1,nti2
         SMinter2(i)=0.d0
      enddo

      do i=1,nelemA1
         aa1(i)=0.d0
         ja1(i)=0
      enddo
      do i=1,nelemA2
         aa2(i)=0.d0
         ja2(i)=0
      enddo

      do i=1,nelemB1
         bb1(i)=0.d0
         jb1(i)=0
      enddo
      do i=1,nelemB2
         bb2(i)=0.d0
         jb2(i)=0
      enddo

c le tenseur de permeabilite est diagonal

      K(1,2)=0.d0
      K(2,1)=K(1,2)
     
      poroh1=0.d0
      poroh2=0.d0

      do i=1,5
         MOY1(i)=0.d0
         MOY2(i)=0.d0
      enddo

 
      RETURN
      end


 



