c      Fichier prelimi21_2D_c.f
c
c******************************************************************
      subroutine PRELIMINAIRE21_2D_c(VECTF1,VECTF2,VECTI1,VECTI2,
     @  TABele,nnf1,nnf2,nti1,nti2,nte,ia1,ia2,
     @        MATA1,MATA2,MATB1,MATB2,MATC1,MATC2,
     @ ord_gr1,ord_gr2,lb,TABnoeud1,TABnoeud2,ntn)
c*****************************************************************
c
c  Cette procedure affecte aux tableaux ia,ib,ic les valeurs definitives
c  en vue de l'assemblage des tableaux aa,bb et cc. Deplus les dimensions 
c  des tableaux aa,bb et cc sont calcules.
c
      implicit none

      integer   nte,i,j,entIF1,entIF2,deb,pos11,pos12
      integer   pos21,pos22,INDICE1,INDICE2,ntn
      integer   VECTF1,VECTF2,VECTI1,VECTI2
      integer   ord_gr1,ord_gr2
      integer   k,lb,nbndele,l,entIV1,entIV2,ind
      integer   TABele,ia1,ia2,m,nb1,nb2
      integer   nnf1,nnf2,nti1,nti2
      integer   MATA1,MATA2,MATB1,MATB2
      integer   MATC1,MATC2
      real*8    TABnoeud1,TABnoeud2
      logical   elementbis1,elementbis2
      dimension MATA1(nti1,*),MATA2(nti2,*)
      dimension MATB1(nnf1,*),MATB2(nnf2,*)
      dimension MATC1(nnf1,*),MATC2(nnf2,*)
      dimension INDICE1(5),INDICE2(5)
      dimension elementbis1(5),elementbis2(5)
      dimension ia1(*),ia2(*),VECTF1(*),VECTF2(*)
      dimension VECTI1(*),VECTI2(*)
      dimension TABele(nte,*) 
      dimension TABnoeud1(ntn,*),TABnoeud2(ntn,*)

c initialisation des tableaux  MATA,MATB,MATC 

      do j=1,lb
         do i=1,nti1
            MATA1(i,j)=-1
         enddo
         do i=1,nti2
            MATA2(i,j)=-1
         enddo
         do i=1,nnf1
            MATB1(i,j)=-1
            MATC1(i,j)=-1
         enddo
         do i=1,nnf2
            MATB2(i,j)=-1
            MATC2(i,j)=-1
         enddo
      enddo

c      write(*,*)'ututu'

      nb1=1
      nb2=1
      ind=1
      do k=1,nte
         do j=2,5
            INDICE1(j)=TABnoeud1(TABele(k,j),4)
            INDICE2(j)=TABnoeud2(TABele(k,j),4)
            if (TABnoeud1(TABele(k,j),3).eq.0) then
                elementbis1(j)=.false.
                                               else
                elementbis1(j)=.true. 
            endif
            if (TABnoeud2(TABele(k,j),3).eq.0) then
                elementbis2(j)=.false.
                                               else
                elementbis2(j)=.true. 
            endif
         enddo
         nbndele=5

c         write(20,*)
c         write(20,*)'element',k
c         write(*,*)'element',k
c         write(20,*)(TABele(k,j),j=1,5)
c         write(20,*)(elementbis1(j),j=1,5)
c         write(20,*)(INDICE1(j),j=1,5)
c         write(20,*)'nbndele',nbndele
         do j=2,(nbndele-1)
                deb=j+1
                pos11=INDICE1(j)
                entIF1=TABele(k,j)
                if (elementbis1(j)) then
                    do m=deb,nbndele
c                    call DECALAGE_2D_c(m,nbndele,dec)
                       entIV1=TABele(k,m)
                       pos21=INDICE1(m)
                       if (elementbis1(m)) then
                           if (entIV1.lt.entIF1) then
c                       write(20,*)'MATA1'
                  call RANGEMENT_2D_c(MATA1,pos11,entIF1,entIV1,lb,nti1) 
                                               else
c                       write(20,*)'MATA1'
                  call RANGEMENT_2D_c(MATA1,pos21,entIF1,entIV1,lb,nti1)
                           endif
                                          else
c                       write(20,*)'MATC1'
                  call RANGEMENT_2D_c(MATC1,pos21,entIF1,entIV1,lb,nnf1)
                           nb1=nb1+1
                       endif
                    enddo
                                    else
                    do m=deb,nbndele
c                    call DECALAGE_2D_c(m,nbndele,dec)
                       entIV1=TABele(k,m)
                       pos21=INDICE1(m)
                       if (.not.(elementbis1(m))) then
                           if (entIV1.lt.entIF1) then
c                       write(20,*)'MATB1'
                  call RANGEMENT_2D_c(MATB1,pos11,entIF1,entIV1,lb,nnf1)
                                               else
c                      write(20,*)'MATB1'
                  call RANGEMENT_2D_c(MATB1,pos21,entIF1,entIV1,lb,nnf1)
                           endif
                                                 else
c                       write(20,*)'MATC1'
                  call RANGEMENT_2D_c(MATC1,pos11,entIF1,entIV1,lb,nnf1)
                           nb1=nb1+1
                       endif
                    enddo
                endif
           enddo 

c         write(20,*)(elementbis2(j),j=1,5)
c         write(20,*)(INDICE2(j),j=1,5)
c         write(20,*)'nbndele',nbndele
         do j=2,(nbndele-1)
                deb=j+1
                pos12=INDICE2(j)
                entIF2=TABele(k,j)
                if (elementbis2(j)) then
                    do m=deb,nbndele
c                    call DECALAGE_2D_c(m,nbndele,dec)
                       entIV2=TABele(k,m)
                       pos22=INDICE2(m)
                       if (elementbis2(m)) then
                           if (entIV2.lt.entIF2) then
c                       write(20,*)'MATA2'
                 call RANGEMENT_2D_c(MATA2,pos12,entIF2,entIV2,lb,nti2)
                                              else
c                       write(20,*)'MATA2'
                 call RANGEMENT_2D_c(MATA2,pos22,entIF2,entIV2,lb,nti2)
                           endif
                                          else
c                       write(20,*)'MATC2'
                 call RANGEMENT_2D_c(MATC2,pos22,entIF2,entIV2,lb,nnf2)
                           nb2=nb2+1
                       endif
                    enddo
                                    else
                    do m=deb,nbndele
c                    call DECALAGE_2D_c(m,nbndele,dec)
                       entIV2=TABele(k,m)
                       pos22=INDICE2(m)
                       if (.not.(elementbis2(m))) then
                           if (entIV2.lt.entIF2) then
c                       write(20,*)'MATB2'
                  call RANGEMENT_2D_c(MATB2,pos12,entIF2,entIV2,lb,nnf2)
                                               else
c                       write(20,*)'MATB2'
                  call RANGEMENT_2D_c(MATB2,pos22,entIF2,entIV2,lb,nnf2)
                           endif
                                                 else
c                       write(20,*)'MATC2'
                  call RANGEMENT_2D_c(MATC2,pos12,entIF2,entIV2,lb,nnf2)
                           nb2=nb2+1
                       endif
                    enddo
                endif
           enddo
       enddo      


c                write(20,*)'***********************'
c                do iii=1,nti1
c                  write(20,*)'MATA1',(MATA1(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATB1',(MATB1(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATC1',(MATC1(iii,jjj),jjj=1,lb)
c                enddo
c                write(20,*)'***********************'

c                write(20,*)'***********************'
c                do iii=1,nti1
c                   write(20,*)'MATA2',(MATA2(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATB2',(MATB2(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATC2',(MATC2(iii,jjj),jjj=1,lb)
c                enddo
c                write(20,*)'***********************'

                    
       do i=1,nti1
          l=1
          do while (MATA1(i,l).ne.-1) 
             l=l+1
          enddo
          ia1(i)=l-1
c          write(20,*)i,' ia1',ia1(i)
       enddo
c          write(20,*)
       do i=1,nti2
          l=1
          do while (MATA2(i,l).ne.-1)
             l=l+1
          enddo
          ia2(i)=l-1
c          write(20,*)i,' ia2',ia2(i)
       enddo
c          write(20,*)

       ord_gr1=nb1+nnf1+100
       ord_gr2=nb2+nnf2+100

c       write(20,*)'nouvel ord-gr1',ord_gr1 
c       write(20,*)'nouvel ord-gr2',ord_gr2

       RETURN
       end





c*****************************************************************
       subroutine RANGEMENT_2D_c(MATA,pos,entIF,entIV,lb,borne)
c*****************************************************************
c
c
       implicit none
       integer MATA,l,lb,pos,entIF,entIV,borne

       dimension MATA(borne,*)

c       write(20,*)'entIF,entIV,pos',entIF,' ',entIV,' ',pos
       l=1
       do while (l.le.lb)
          if (MATA(pos,l).ne.entIF+entIV) then      
              if (MATA(pos,l).eq.-1) then
                  MATA(pos,l)=entIF+entIV
c                  write(20,*)'MAT',(MATA(pos,k),k=1,100)
                  RETURN
                                     else
                  l=l+1
              endif
                                          else
              RETURN
          endif
       enddo
       
       RETURN
       end


c*****************************************************************
       subroutine DECALAGE_2D_c(j,nbndele,dec)
c****************************************************************
c
c
       implicit none
       integer j,nbndele,dec

       if ((j.eq.5).and.(nbndele.eq.5)) then
          dec=j+1
             else
          dec=j
       endif

       RETURN
       end



