c      Fichier prelimi22_c.f
c
c******************************************************************
      subroutine PRELIMINAIRE22_C(VECTF1,VECTF2,VECTF3,VECTI1,VECTI2,
     @           VECTI3,TABele,nnf1,nnf2,nnf3,nti1,nti2,nti3,nte,
     @           ic1,ic2,ic3,nelemC1,nelemC2,nelemC3,VECT11,VECT12,
     @           VECT13,ib1,ib2,ib3,nelemB1,nelemB2,nelemB3,
     @           ia1,ia2,ia3,nelemA1,nelemA2,nelemA3,
     @           MATB1,MATB2,MATB3,MATC1,MATC2,MATC3)
c*****************************************************************
c
c  Cette procedure affecte aux tableaux ia,ib,ic les valeurs definitives
c  en vue de l'assemblage des tableaux aa,bb et cc. Deplus les dimensions 
c  des tableaux aa,bb et cc sont calcules.
c
      implicit none

      integer   nte,i,j
      integer   VECTF1,VECTF2,VECTF3,VECTI1,VECTI2,VECTI3
      integer   nnf1,nnf2,nnf3,nti1,nti2,nti3
      integer   ic1,ic2,ic3,nelemC1,nelemC2,nelemC3
      integer   VECT11,VECT12,VECT13,ib1,ib2,ib3
      integer   nelemB1,nelemB2,nelemB3,ia1,ia2,ia3
      integer   nelemA1,nelemA2,nelemA3
      integer   l,ind
      integer   MATB1,MATB2,MATB3,MATC1,MATC2,MATC3
      integer   TABele,a,b,ivois,pos,nb
      dimension TABele(nte,*) 
      dimension MATB1(nnf1,*),MATB2(nnf2,*),MATB3(nnf3,*)
      dimension MATC1(nnf1,*),MATC2(nnf2,*),MATC3(nnf3,*)
      dimension VECTF1(*),VECTF2(*),VECTF3(*)
      dimension VECTI1(*),VECTI2(*),VECTI3(*)
      dimension ia1(*),ia2(*),ia3(*),ib1(*),ib2(*),ib3(*)
      dimension ic1(*),ic2(*),ic3(*),VECT11(*),VECT12(*),VECT13(*)

       ind=1
       do i=1,nnf1
          l=1
          j=1
          do while (MATB1(i,l).ne.-1)
             l=l+1
          enddo
          do while (MATC1(i,j).ne.-1)
             nb=MATC1(i,j)-VECTF1(i)
             pos=1
             do while ((nb.ne.VECTI1(pos)).and.(pos.le.nti1)) 
                pos=pos+1
             enddo
             VECT11(ind)=pos
             ind=ind+1
             j=j+1
          enddo
          ib1(i)=l-1
          ic1(i)=j-1
          if (ic1(i).eq.0) then
             VECT11(ind)=0
             ind=ind+1
             ic1(i)=1
          endif
       enddo

       ind=1
       do i=1,nnf2
          l=1
          j=1
          do while (MATB2(i,l).ne.-1)
             l=l+1
          enddo
          do while (MATC2(i,j).ne.-1)
             nb=MATC2(i,j)-VECTF2(i)
             pos=1
             do while ((nb.ne.VECTI2(pos)).and.(pos.le.nti2))
                pos=pos+1
             enddo
             VECT12(ind)=pos
             ind=ind+1
             j=j+1
          enddo
          ib2(i)=l-1
          ic2(i)=j-1
          if (ic2(i).eq.0) then
             VECT12(ind)=0
             ind=ind+1
             ic2(i)=1
          endif
       enddo

       ind=1
       do i=1,nnf3
          l=1
          j=1
          do while (MATB3(i,l).ne.-1)
             l=l+1
          enddo
          do while (MATC3(i,j).ne.-1)
             nb=MATC3(i,j)-VECTF3(i)
             pos=1
             do while ((nb.ne.VECTI3(pos)).and.(pos.le.nti3))
                pos=pos+1
             enddo
             VECT13(ind)=pos
             ind=ind+1
             j=j+1
          enddo
          ib3(i)=l-1
          ic3(i)=j-1
          if (ic3(i).eq.0) then
             VECT13(ind)=0
             ind=ind+1
             ic3(i)=1
          endif
       enddo


c calcul du tableau ic final ainsi que nelemC

      a=ic1(1)
      ic1(1)=1
      do i=1,nnf1-1
         b=ic1(i+1)
         ic1(i+1)=ic1(i)+a
         a=b
      enddo
      ic1(nnf1+1)=ic1(nnf1)+a
      nelemC1=ic1(nnf1)+a-1

c      write(20,*)
c      write(20,*)'ic1 final'
c      do i=1,nnf1+1
c          write(20,*)ic1(i)
c      enddo
c      write(20,*)'nelemC1',nelemC1
c      write(20,*)'le veritable ord_gr1',nelemC1

      a=ic2(1)
      ic2(1)=1
      do i=1,nnf2-1
         b=ic2(i+1)
         ic2(i+1)=ic2(i)+a
         a=b
      enddo
      ic2(nnf2+1)=ic2(nnf2)+a
      nelemC2=ic2(nnf2)+a-1

c      write(20,*)
c      write(20,*)'ic2 final'
c      do i=1,nnf2+1
c          write(20,*)ic2(i)
c      enddo
c      write(20,*)'nelemC2',nelemC2
c      write(20,*)'le veritable ord_gr2',nelemC2

      a=ic3(1)
      ic3(1)=1
      do i=1,nnf3-1
         b=ic3(i+1)
         ic3(i+1)=ic3(i)+a
         a=b
      enddo
      ic3(nnf3+1)=ic3(nnf3)+a
      nelemC3=ic3(nnf3)+a-1

c      write(20,*)
c      write(20,*)'ic3 final'
c      do i=1,nnf3+1
c          write(20,*)ic3(i)
c      enddo
c      write(20,*)'nelemC3',nelemC3
c      write(20,*)'le veritable ord_gr3',nelemC3


c calcul du tableau ib final ainsi que nelemB

      nelemB1=0
      do i=1,nnf1
         ivois=ib1(i)
         ib1(i)=nelemB1+1
         nelemB1=nelemB1+ivois+1
      enddo
      ib1(nnf1+1)=nelemB1+1

c      write(20,*)
c      write(20,*)'ib1 final'
c      do i=1,nnf1+1
c          write(20,*)ib1(i)
c      enddo
c      write(20,*)'nelemB1',nelemB1

      nelemB2=0
      do i=1,nnf2
         ivois=ib2(i)
         ib2(i)=nelemB2+1
         nelemB2=nelemB2+ivois+1
      enddo
      ib2(nnf2+1)=nelemB2+1

c      write(20,*)
c      write(20,*)'ib2 final'
c      do i=1,nnf2+1
c          write(20,*)ib2(i)
c      enddo
c      write(20,*)'nelemB2',nelemB2

      nelemB3=0
      do i=1,nnf3
         ivois=ib3(i)
         ib3(i)=nelemB3+1
         nelemB3=nelemB3+ivois+1
      enddo
      ib3(nnf3+1)=nelemB3+1

c      write(20,*)
c      write(20,*)'ib3 final'
c      do i=1,nnf3+1
c          write(20,*)ib3(i)
c      enddo
c      write(20,*)'nelemB3',nelemB3

c calcul du tableau ia final ainsi que nelemA

      nelemA1=0
      do i=1,nti1
         ivois=ia1(i)
         ia1(i)=nelemA1+1
         nelemA1=nelemA1+ivois+1
      enddo
      ia1(nti1+1)=nelemA1+1

c      write(20,*)
c      write(20,*)'ia1 final'
c      do i=1,nti1+1
c          write(20,*)i,ia1(i)
c      enddo
c      write(20,*)'nelemA1',nelemA1

      nelemA2=0
      do i=1,nti2
         ivois=ia2(i)
         ia2(i)=nelemA2+1
         nelemA2=nelemA2+ivois+1
      enddo
      ia2(nti2+1)=nelemA2+1

c      write(20,*)
c      write(20,*)'ia2 final'
c      do i=1,nti2+1
c          write(20,*)i,ia2(i)
c      enddo
c      write(20,*)'nelemA2',nelemA2

      nelemA3=0
      do i=1,nti3
         ivois=ia3(i)
         ia3(i)=nelemA3+1
         nelemA3=nelemA3+ivois+1
      enddo
      ia3(nti3+1)=nelemA3+1

c      write(20,*)
c      write(20,*)'ia3 final'
c      do i=1,nti3+1
c          write(20,*)i,ia3(i)
c      enddo
c      write(20,*)'nelemA3',nelemA3

      RETURN
      end



