c   Fichier module_2D_NC_c.f
c
c**********************************************************************
c     FICHIERS NECESSAIRES A LA SUBROUTINE PRINCIPALE
c**********************************************************************
c
      INCLUDE'BIB/permequi_2D_c.f'
      INCLUDE'BIB/nfr_nint1_2D_c.f'
      INCLUDE'BIB/2nd_memb_2D_c.f'
      INCLUDE'BIB/quadrila_c.f'
      INCLUDE'BIB/mise_a_0_2D_c.f'
      INCLUDE'BIB/prelimi21_2D_c.f'
      INCLUDE'BIB/prelimi22_2D_c.f'
      INCLUDE'BIB/fonct_2m_2D_c.f'
      INCLUDE'BIB/jc_2D_c.f'

c****************************************************************
c****************************************************************        
      
      subroutine MODULE_2D_NC_c(ntn,nte,err,RESULTATS_MC,nbgros,eps,
     @                     ig,kmax,nti,nnf,nti1,nti2,nti3,MaMO,
     @                     TABele,PETRO,COORD_POS)

c****************************************************************
c*auteur   Thierry Hontans 
c*auteur   Docteur en mathematiques appliquees
c****************************************************************        
c*ver     version du 04/03/99
c****************************************************************        

c    Ce programme calcule un tenseur homogeneise suivant la
c    methode du mode confine en 2D

      implicit none

      integer i,j,chele,ntn,ord_gr1,ord_gr2,nte,nbgros,nti,nnf
      integer nti1,nti2,nnf1,nnf2,pb1,pb2,pb3,err,nti3,MaMO
      integer lb,kmax,ig,P       !,st1,st2
      integer nelemA1,nelemA2
      integer nelemB1,nelemB2
      integer nelemC1,nelemC2
      integer INDICE1,INDICE2,TABele(nte,*)
      real*8  K,N1,N2,N3,N4,eps  !,aux,aux1,aux2,aux3,aux4  
      real*8  poro,poroh1,MOY1,poroh2,MOY2,K_MA,airepr
      real*8  aire1,aire2,RESULTATS_MC,aire,PETRO(nte,*)
      real*8  COORD_POS(ntn,*)
      logical ELEMENTBIS1,ELEMENTBIS2,bo1

      parameter (lb=100) !on peut descendre a 30 ( a verifier )

      dimension N1(3),N2(3),N3(3),N4(3)
      dimension K(2,2),MOY1(5),MOY2(5)
      dimension ELEMENTBIS1(5),ELEMENTBIS2(5),P(7)
      dimension INDICE1(5),INDICE2(5)
      dimension RESULTATS_MC(nbgros,*)

      integer VECTI1(:)
      ALLOCATABLE VECTI1
      integer VECTI2(:)
      ALLOCATABLE VECTI2
      integer VECTF1(:)
      ALLOCATABLE VECTF1
      integer VECTF2(:)
      ALLOCATABLE VECTF2
      integer ia1(:)
      ALLOCATABLE ia1
      integer ia2(:)
      ALLOCATABLE ia2
      integer ja1(:)
      ALLOCATABLE ja1
      integer ja2(:)
      ALLOCATABLE ja2 
      integer ib1(:)
      ALLOCATABLE ib1
      integer ib2(:)
      ALLOCATABLE ib2
      integer jb1(:)
      ALLOCATABLE jb1
      integer jb2(:)
      ALLOCATABLE jb2
      integer ic1(:)
      ALLOCATABLE ic1
      integer ic2(:)
      ALLOCATABLE ic2
      integer jc1(:)
      ALLOCATABLE jc1
      integer jc2(:)
      ALLOCATABLE jc2
      integer VECT11(:)
      ALLOCATABLE VECT11
      integer VECT12(:)
      ALLOCATABLE VECT12
      integer MATA1(:,:)
      ALLOCATABLE MATA1
      integer MATA2(:,:)
      ALLOCATABLE MATA2
      integer MATB1(:,:)
      ALLOCATABLE MATB1
      integer MATB2(:,:)
      ALLOCATABLE MATB2
      integer MATC1(:,:)
      ALLOCATABLE MATC1
      integer MATC2(:,:)
      ALLOCATABLE MATC2

      real*8 TABnoeud1(:,:)
      ALLOCATABLE TABnoeud1
      real*8 TABnoeud2(:,:)
      ALLOCATABLE TABnoeud2

      real*8 SMinter1(:)
      ALLOCATABLE SMinter1
      real*8 SMinter2(:)
      ALLOCATABLE SMinter2
      real*8 SM1(:)
      ALLOCATABLE SM1
      real*8 SM2(:)
      ALLOCATABLE SM2
      real*8 X1(:)
      ALLOCATABLE X1
      real*8 X2(:)
      ALLOCATABLE X2
      real*8 CONDB1(:)
      ALLOCATABLE CONDB1
      real*8 CONDB2(:)
      ALLOCATABLE CONDB2
      real*8 aa1(:)
      ALLOCATABLE aa1
      real*8 aa2(:)
      ALLOCATABLE aa2

      real*8 al1(:)
      ALLOCATABLE al1
      real*8 al2(:)
      ALLOCATABLE al2
      real*8 bb1(:)
      ALLOCATABLE bb1
      real*8 bb2(:)
      ALLOCATABLE bb2
      real*8 cc1(:)
      ALLOCATABLE cc1
      real*8 cc2(:)
      ALLOCATABLE cc2
      real*8 gg(:)
      ALLOCATABLE gg
      real*8 h(:)
      ALLOCATABLE h  
      real*8 cg(:)
      ALLOCATABLE cg

c      write(*,*)'LECTURE DU MAILLAGE'
c      write(*,*)'on rentre dans le 2D'

c on lit le nombre total de noeud et le nombre total d'element du maillage
c plus le nombre d'inconues et le nombre de noeud frontalier 

      REWIND(11)
c      read(11,*)(P(i),i=1,7)
      P(1)=ntn
      P(2)=nte
      P(3)=nti
      P(4)=nnf
      P(5)=nti1
      P(6)=nti2
      P(7)=nti3
c      write(20,*)ntn,nte,nti,nnf,nti1,nti2,nti3      

           if (P(5).eq.0) then
               pb1=2
               pb2=3
               pb3=1
               nti1=P(6)/2
               nti2=P(7)/2
                          else
               if (P(6).eq.0) then
                    pb1=1
                    pb2=3
                    pb3=2
                    nti1=P(5)/2
                    nti2=P(7)/2
                              else
                    if (P(7).eq.0) then
                        pb1=1
                        pb2=2
                        pb3=3
                        nti1=P(5)/2
                        nti2=P(6)/2
                                   else
                        write(*,*)'Appel au 2D non necessaire'
                        STOP
                    endif
               endif
           endif
      ntn=P(1)/2
      nte=P(2)
      nnf1=ntn-nti1
      nnf2=ntn-nti2
c      write(20,*)ntn,nte,nti1,nti2,nnf1,nnf2
c      write(*,*)ntn,nte,nti1,nti2,nnf1,nnf2

c allocation dynamique de memoire des tableaux 

      ALLOCATE (VECTI1(nti1))
      ALLOCATE (VECTI2(nti2))
      ALLOCATE (VECTF1(nnf1))
      ALLOCATE (VECTF2(nnf2))
      ALLOCATE (TABnoeud1(ntn,4))
      ALLOCATE (TABnoeud2(ntn,4))

c on range les elements du maillage dans le tableau TABele
c ainsi que la valeur de la permeabilite et de la porosite
c de l'element considere

c      write(*,*)'Rangements des elements du maillage dans un tableaux.'
c      write(20,*)'Rangements des elements du maillage dans un tableaux.'
c      do i=1,nte
c         read(11,*)(TABele(i,j),j=1,5),aux1,aux2,aux3,aux4,
c     @             (PETRO(i,j),j=1,4)
c         write(20,*)(TABele(i,j),j=1,5),' ',(PETRO(i,j),j=1,4)
c      enddo


c on remplie VECTI des noeuds interieur et VECTF des noeuds frontaliers
c attention les VECTI et les VECTF doivent etre ranges dans l''ordre
c croissant des numeros

      call REMPLIR1_2D_c(VECTI1,VECTI2,VECTF1,VECTF2,
     @               TABnoeud1,TABnoeud2,ntn,pb1,pb2,COORD_POS,bo1)



c si le nombre d'inconuues vaut zero on affecte a
c la maille grossiere la moyenne arithmetique.
c (une meilleure solution serait le raffinement de maillage)

      if ((nti1.eq.0).or.(nti2.eq.0).or.(bo1)) then
            RESULTATS_MC(ig,1)=0.d0
            RESULTATS_MC(ig,2)=0.d0
            RESULTATS_MC(ig,3)=0.d0
            RESULTATS_MC(ig,4)=0.d0
            aire=0.d0
            do i=1,ntn
               read(11,*)(TABnoeud1(i,j),j=1,4)
            enddo
         do i=1,nte
            N1(2)=TABnoeud1(TABele(i,2),pb1+1)
            N1(3)=TABnoeud1(TABele(i,2),pb2+1)
            N2(2)=TABnoeud1(TABele(i,3),pb1+1)
            N2(3)=TABnoeud1(TABele(i,3),pb2+1)
            N3(2)=TABnoeud1(TABele(i,4),pb1+1)
            N3(3)=TABnoeud1(TABele(i,4),pb2+1)
            N4(2)=TABnoeud1(TABele(i,5),pb1+1)
            N4(3)=TABnoeud1(TABele(i,5),pb2+1)
            call AIRE_ELE2_c(aire1,N1,N2,N3)
            call AIRE_ELE2_c(aire2,N3,N4,N1)
            aire=aire+(aire1+aire2)
            RESULTATS_MC(ig,1)=RESULTATS_MC(ig,1)+
     @                         (PETRO(i,1)*(aire1+aire2))
            RESULTATS_MC(ig,2)=RESULTATS_MC(ig,2)+
     @                         (PETRO(i,2)*(aire1+aire2))
            RESULTATS_MC(ig,3)=RESULTATS_MC(ig,3)+
     @                         (PETRO(i,3)*(aire1+aire2))
            RESULTATS_MC(ig,4)=RESULTATS_MC(ig,4)+
     @                         (PETRO(i,4)*(aire1+aire2))
         enddo
         RESULTATS_MC(ig,1)=RESULTATS_MC(ig,1)/aire
         RESULTATS_MC(ig,2)=RESULTATS_MC(ig,2)/aire
         RESULTATS_MC(ig,3)=RESULTATS_MC(ig,3)/aire
         RESULTATS_MC(ig,4)=RESULTATS_MC(ig,4)/aire
         DEALLOCATE (VECTI1)
         DEALLOCATE (VECTI2)
         DEALLOCATE (VECTF1)
         DEALLOCATE (VECTF2)
         DEALLOCATE (TABnoeud1)
         DEALLOCATE (TABnoeud2)
         err=1
         GOTO 777
       endif



c      write(20,*)'ATTENTION les VECTI et les VECTF doivent etre '
c      write(20,*)'ranges dans l''ordre croissant'
c      write(20,*)'VECTF1'
c      write(20,*)(VECTF1(i),i=1,nnf1)
c      write(20,*)
c      write(20,*)'VECTI1'
c      write(20,*)(VECTI1(i),i=1,nti1)
c      write(20,*)
c      write(20,*)'VECTF2'
c      write(20,*)(VECTF2(i),i=1,nnf2)
c      write(20,*)
c      write(20,*)'VECTI2'
c      write(20,*)(VECTI2(i),i=1,nti2)
c      write(20,*)

c allocation dynamique de memoire de tableaux 

      ALLOCATE(MATA1(nti1,lb))
      ALLOCATE(MATA2(nti2,lb))
      ALLOCATE(MATB1(nnf1,lb))
      ALLOCATE(MATB2(nnf2,lb))
      ALLOCATE(MATC1(nnf1,lb))
      ALLOCATE(MATC2(nnf2,lb))
      ALLOCATE (ia1(nti1+1))
      ALLOCATE (ia2(nti2+1))

      write(*,*)'prelimi'

      call PRELIMINAIRE21_2D_c(VECTF1,VECTF2,VECTI1,VECTI2,
     @     TABele,nnf1,nnf2,nti1,nti2,nte,ia1,ia2,
     @     MATA1,MATA2,MATB1,MATB2,MATC1,MATC2,
     @ ord_gr1,ord_gr2,lb,TABnoeud1,TABnoeud2,ntn)

c on rend la memoire du tableau au systeme

      DEALLOCATE(MATA1)
      DEALLOCATE(MATA2)

c allocation dynamique de memoire de tableaux

      ALLOCATE (VECT11(ord_gr1))
      ALLOCATE (ic1(nnf1+1))
      ALLOCATE (ib1(nnf1+1))
      ALLOCATE (VECT12(ord_gr2))
      ALLOCATE (ic2(nnf2+1))
      ALLOCATE (ib2(nnf2+1))

      call PRELIMINAIRE22_2D_c(VECTF1,VECTF2,VECTI1,VECTI2,
     @           TABele,nnf1,nnf2,nti1,nti2,nte,
     @           ic1,ic2,nelemC1,nelemC2,VECT11,VECT12,
     @           ib1,ib2,nelemB1,nelemB2,
     @           ia1,ia2,nelemA1,nelemA2,
     @           MATB1,MATB2,MATC1,MATC2)


c on rend la memoire des tableaux au systeme

      DEALLOCATE(MATB1)
      DEALLOCATE(MATB2)
      DEALLOCATE(MATC1)
      DEALLOCATE(MATC2)

c allocation dynamique de memoire des tableaux cc,jc

      ALLOCATE (cc1(nelemC1))
      ALLOCATE (jc1(nelemC1))
      ALLOCATE (cc2(nelemC2))
      ALLOCATE (jc2(nelemC2))

c calcul du tableau ic et initialisation du tableau cc

      call CAL_JC_2D_c(VECT11,VECT12,jc1,jc2,
     @             nelemC1,nelemC2,ntn,cc1,cc2)

c on rend la memoire du tableau VECT1 au systeme

      DEALLOCATE(VECT11)
      DEALLOCATE(VECT12)

c allocation dynamique de memoire des tableaux aa,bb,ja,jb,al,SMinter
      
      ALLOCATE (aa1(nelemA1))
      ALLOCATE (al1(nelemA1))
      ALLOCATE (ja1(nelemA1)) 
      ALLOCATE (bb1(nelemB1))
      ALLOCATE (jb1(nelemB1))
      ALLOCATE (SMinter1(nti1))

      ALLOCATE (aa2(nelemA2))
      ALLOCATE (al2(nelemA2))
      ALLOCATE (ja2(nelemA2))
      ALLOCATE (bb2(nelemB2))
      ALLOCATE (jb2(nelemB2))
      ALLOCATE (SMinter2(nti2))

c      write(*,*)'CALCUL DES CONTRIBUTIONS ET ASSEMBLAGE'
c      write(20,*)'CALCUL DES CONTRIBUTIONS ET ASSEMBLAGE'            

c initialisation de tous les tableaux a zero

      call MISE_A_ZERO_2D_c(bb1,bb2,jb1,jb2,aa1,aa2,
     @      ja1,ja2,K,SMinter1,SMinter2,nti1,nti2,
     @      nelemA1,nelemA2,nelemB1,nelemB2,
     @      poroh1,MOY1,poroh2,MOY2,aire1,aire2)

      K_MA=0.d0
      airepr=0.d0

c on boucle sur les elements
c on construit la matrice du systeme lineaire A 

      do chele=1,nte

c         write(*,*)'chele',chele
c on affecte la permeabilite et la porosite de l'element considere

         K(1,1)=PETRO(chele,pb1)
         K(2,2)=PETRO(chele,pb2)              
         poro=PETRO(chele,4)               

c on donne les informations de l'element

         do j=2,5
            INDICE1(j)=TABnoeud1(TABele(chele,j),4)
            INDICE2(j)=TABnoeud2(TABele(chele,j),4)
            if (TABnoeud1(TABele(chele,j),3).eq.0) then
                elementbis1(j)=.false.
                                               else
                elementbis1(j)=.true. 
            endif
            if (TABnoeud2(TABele(chele,j),3).eq.0) then
                elementbis2(j)=.false.
                                               else
                elementbis2(j)=.true. 
            endif
         enddo
         do j=1,2
            N1(j+1)=TABnoeud1(TABele(chele,2),j)
            N2(j+1)=TABnoeud1(TABele(chele,3),j)
            N3(j+1)=TABnoeud1(TABele(chele,4),j)
            N4(j+1)=TABnoeud1(TABele(chele,5),j)
         enddo


c calcul de la contribution et assemblage pour un hexaedre

        call CALCULQ1_2D_c(ELEMENTBIS1,INDICE1,bb1,ib1,jb1,aa1,ia1,ja1,
     @        SMinter1,N1,N2,N3,N4,K,cc1,ic1,jc1,aire1,
     @        poro,poroh1)
        K_MA=K_MA+(PETRO(chele,pb3)*(aire1-airepr))
        airepr=aire1

        call CALCULQ1_2D_c(ELEMENTBIS2,INDICE2,bb2,ib2,jb2,aa2,ia2,ja2,
     @        SMinter2,N1,N2,N3,N4,K,cc2,ic2,jc2,aire2,
     @        poro,poroh2)

c        write(20,*)'aire',aire1,aire2

      enddo
      K_MA=K_MA/aire1


c      write(*,*)'CONSTITUTION DES 3 SYSTEMES LINEAIRES ET RESOLUTION'

c      do i=1,nelemC1
c         write(20,*)i,'cc1=',cc1(i),'    jc1=',jc1(i)
c      enddo
c      do i=1,nelemC2
c         write(20,*)i,'cc2=',cc2(i),'    jc2=',jc2(i)
c      enddo

c on tri le tableau aa
                 
      do i=1,nti1
        call TRI_c(ja1(ia1(i)),aa1(ia1(i)),ia1(i+1)-ia1(i))
      enddo

      do i=1,nti2
        call TRI_c(ja2(ia2(i)),aa2(ia2(i)),ia2(i+1)-ia2(i))
      enddo

c on tri le tableau bb

      do i=1,nnf1
        call TRI_c(jb1(ib1(i)),bb1(ib1(i)),ib1(i+1)-ib1(i))
      enddo

      do i=1,nnf2
        call TRI_c(jb2(ib2(i)),bb2(ib2(i)),ib2(i+1)-ib2(i))
      enddo


c      do i=1,nelemB1
c         write(20,*)i,'bb1=',bb1(i),'    jb1=',jb1(i)
c      enddo
c      do i=1,nelemB2
c         write(20,*)i,'bb2=',bb2(i),'    jb2=',jb2(i)
c      enddo

c      do i=1,nelemA1
c         write(20,*)i,'aa1=',aa1(i),'    ja1=',ja1(i)
c      enddo
c      do i=1,nelemA2
c         write(20,*)i,'aa2=',aa2(i),'    ja2=',ja2(i)
c      enddo

c  calcul de la factorise de choleski incomplete

       call ICholeski_c(nti1,aa1,ia1,ja1,al1)
       call ICholeski_c(nti2,aa2,ia2,ja2,al2)

c      write(20,*)'factorise de choleski'
c      do i=1,nelemA1
c         write(20,*)'al1=',al1(i)
c      enddo

c on rend la memoire du tableau TABele au systeme


c allocation dynamique de memoire des tableaux SM,CONDB1,CONDB2,
c X1,X2

      ALLOCATE (SM1(nti1))
      ALLOCATE (SM2(nti2))
      ALLOCATE (CONDB1(nnf1))
      ALLOCATE (CONDB2(nnf2))
      ALLOCATE (X1(nti1))
      ALLOCATE (X2(nti2))

c on initialise a zero le vecteur X1 et on affecte le vecteur SMinter au
c vecteur SM
      
      do i=1,nti1
         SM1(i)=SMinter1(i)
c         write(20,*)'SMinter1',SMinter1(i)
         X1(i)=0.d0
      enddo

c on affecte les conditions aux limites du probleme local 1 au vecteur SM

      call SECOND_MEMB_2D_c(cc1,ic1,jc1,CONDB1,SM1,nnf1,ntn,
     @                 TABnoeud1,nti1,VECTF1,1) 

      DEALLOCATE (VECTI1)
      DEALLOCATE (VECTF1)
      DEALLOCATE (SMinter1)

c      write(20,*)'SM1'
c      do i=1,nti1
c         write(20,*)SM1(i)
c      enddo


c allocation dynamique de memoire des tableaux gg,h,cg

      ALLOCATE (gg(nti1))
      ALLOCATE (h(nti1))
      ALLOCATE (cg(nti1))

c on resout le systeme lineaire relatif au probleme local 1
      
      call GradC_c(nti1,aa1,ia1,ja1,al1,SM1,X1,gg,h,cg,kmax,eps)
      DEALLOCATE (gg)
      DEALLOCATE (h)
      DEALLOCATE (cg)
      DEALLOCATE (al1)
      DEALLOCATE (SM1)
c      write(20,*)
c      write(20,*)'1 ere solution'
c      call ecrire(X1,nti1)
       
c on initialise a zero le vecteur X2 et on affecte le vecteur SMinter au
c vecteur SM
      
      do i=1,nti2
c         write(20,*)SM2(i)
         SM2(i)=SMinter2(i)
         X2(i)=0.d0
      enddo

c on affecte les conditions aux limites du probleme local 2 au vecteur SM

      call SECOND_MEMB_2D_c(cc2,ic2,jc2,CONDB2,SM2,nnf2,ntn,
     @                 TABnoeud2,nti2,VECTF2,2) 

      DEALLOCATE (VECTI2)
      DEALLOCATE (VECTF2)
      DEALLOCATE (SMinter2)

c      write(20,*)
c      do i=1,nti2
c         write(20,*)SM2(i)
c      enddo

      ALLOCATE (gg(nti2))
      ALLOCATE (h(nti2))
      ALLOCATE (cg(nti2))

c on resout le systeme lineaire relatif au probleme local 2
      
      call GradC_c(nti2,aa2,ia2,ja2,al2,SM2,X2,gg,h,cg,kmax,eps)
c      write(20,*)
c      write(20,*)'2 eme solution'
c      call ecrire(X2,nti2)

      DEALLOCATE (gg)
      DEALLOCATE (h)
      DEALLOCATE (cg)
      DEALLOCATE (al2)
      DEALLOCATE (SM2)

c on rend la memoire des tableaux au systeme 

      DEALLOCATE (TABnoeud1)
      DEALLOCATE (TABnoeud2)

c      write(*,*)'CALCUL DU TENSEUR HOMOGENEISE'

c on calcule la permeabilite homogeneise

c       write(20,*)'avant'
c       write(20,*)'aire',aire1

      call PERMEAEQUI_2D_c(aa1,aa2,ia1,ia2,ja1,ja2,X1,X2,
     @           nti1,nti2,nnf1,nnf2,aire1,CONDB1,CONDB2,
     @        bb1,bb2,ib1,ib2,jb1,jb2,cc1,cc2,
     @    ic1,ic2,jc1,jc2,poroh1,MOY1,RESULTATS_MC,ig,nbgros,pb1,pb2)

      RESULTATS_MC(ig,pb3)=K_MA

c on rend la memoire des tableau au systeme
     
      DEALLOCATE (ia1)
      DEALLOCATE (ib1)
      DEALLOCATE (ic1)
      DEALLOCATE (ja1)
      DEALLOCATE (jb1)
      DEALLOCATE (jc1)
      DEALLOCATE (aa1)
      DEALLOCATE (bb1)
      DEALLOCATE (cc1)

      DEALLOCATE (ia2)
      DEALLOCATE (ib2)
      DEALLOCATE (ic2)
      DEALLOCATE (ja2)
      DEALLOCATE (jb2)
      DEALLOCATE (jc2)
      DEALLOCATE (aa2)
      DEALLOCATE (bb2)
      DEALLOCATE (cc2)

      DEALLOCATE (CONDB1)
      DEALLOCATE (CONDB2)
      DEALLOCATE (X1)
      DEALLOCATE (X2)

c      write(*,*)'nombre d''inconnues du systeme1: ',nti1
c      write(*,*)'nombre d''inconnues du systeme2: ',nti2
c      write(*,*)
c      write(*,*)'fin de l''application'


777   CONTINUE
c      write(*,*)'fin du module 2D'

      end





 
