c
c  this common block contains the flags for doing input and output in the
c permeability interface. the values are read in from a data set provided by
c the user.
c
c output flags
c ------------
c
c   these flags tell the code whether or not to write data for a given variable
c   in the simulation. if iflag is one of the flags defined below, then the
c   following rules are followed:
c
c     0. if iflag=-1, output is done only for the initial condition
c     1. if iflag=0, no output is done
c     2. if iflag=1, output is done each time this routine is called
c     3. if iflag=n, output is done each nth time this routine is called
c
c   iopor - print out the permeability tensor whenever the output routine is
c           called 
c   iopormap - print out the permeability map whenever the output routine is
c              called 
c
      common /iopor/ iopor,iopormap
      data nporout / 20 /
