***************************************************************************
** fonctionstests.f


*     fichier contenant les fonctions de base sur K^
*
*              3----------4
*              |          |
*              |          |
*              |    K^    |
*              |          |
*              |          |
*              1----------2
*
*
*

*     ft1   fonction test pour le sommet 1
*     ft2   fonction test pour le sommet 2
*     ft3   fonction test pour le sommet 3
*     ft4   fonction test pour le sommet 4



      real function ft1(x,y,a,b)

      implicit none
      real x,y,a,b

      ft1=((1-x)/2+a*3./4*(1-x*x))*((1-y)/2+b*3./4*(1-y*y))

      return

      end

***************************************************************************

      real function ft2(x,y,a,b)

      implicit none
      real x,y,a,b

      ft2=((1+x)/2+a*3./4*(1-x*x))*((1-y)/2+b*3./4*(1-y*y))

      return

      end

***************************************************************************

      real function ft3(x,y,a,b)

      implicit none
      real x,y,a,b

      ft3=((1-x)/2+a*3./4*(1-x*x))*((1+y)/2+b*3./4*(1-y*y))

      return

      end

***************************************************************************

      real function ft4(x,y,a,b)

      implicit none
      real x,y,a,b

      ft4=((1+x)/2+a*3./4*(1-x*x))*((1+y)/2+b*3./4*(1-y*y))

      return

      end
