*** fichier pmat.f

*** procedure qui permet la multiplication d'une matrice (stockee sous forme morse) avec un vecteur : A*x= ax


      subroutine pmat(n,x,ax,ind,a,ia,ja,b)
*  n : dimension du systeme
*  x : vecteur multiplicateur
*  a : vecteur contenant les elements de la matrice A
* ia : vecteur contenant la position dans a des premiers elements non nuls de chaque ligne
* ja : vecteur contenat les colonnes de chaque element de a
*  b : vecteur second membre du systeme A*x = b
*ind : prend 0 ou 1 ; on calcule A*x si ind = 0 et b - A*x si ind = 1
* ax : vecteur contenant le resultat de la multiplication
       
      implicit none
      
      real ax(*),b(*),a(*),x(*)
      integer ind,ia(*),ja(*),n
      integer i,k
      real som

      do 2 i=1,n,1
         som=0.0
         do 3 k=ia(i),ia(i+1)-1
            som=som+a(k)*x(ja(k))
 3       continue
         ax(i)=som
 2    continue   

      if (ind .eq. 1) then  
         do 4 i=1,n
 4          ax(i)=b(i)-ax(i)
       end if
       
       return
       end
      
