c  Fichier 2mb_qua_c.f
c
c**************************************************************
      real*8 function INTEGRPQ_2D_c(nbr1,N1,N2,N3,N4)           
c**************************************************************
c
c  Cette fonction calcule l'approximation de l'integrale de
c  (f*fonction de base) sur un quadrilatere.
c  On utilise la formule p.??? du  livre 'PRESENTATION DE LA METHODE
c  DES ELEMENTS FINIS' (T.Touzot) 19??.
c
c  N1,N2,N3,N4: contient les numeros, ainsi que les coordonnees
c               des quatre points qui constituent le quadrilatere.
c  nbr1: numero designant la nbr1ieme fonction de base du
c        quadrilatere.
c 

      implicit none

      integer   nbr1
      real*8    somme1,BASEC,N1,N2,N3,N4,det,a,FONCT_2D_c,x,y
      dimension N1(*),N2(*),N3(*),N4(*),BASEC(4)

      a=1.d0/SQRT(3.d0)
      
      call FBASEC_2D_c(BASEC,det,N1,N2,N3,N4,a,a,x,y) 
      somme1=(FONCT_2D_c(x,y)*BASEC(nbr1))           
      call FBASEC_2D_c(BASEC,det,N1,N2,N3,N4,-a,a,x,y) 
      somme1=somme1+(FONCT_2D_c(x,y)*BASEC(nbr1))            
      call FBASEC_2D_c(BASEC,det,N1,N2,N3,N4,a,-a,x,y) 
      somme1=somme1+(FONCT_2D_c(x,y)*BASEC(nbr1))             
      call FBASEC_2D_c(BASEC,det,N1,N2,N3,N4,-a,-a,x,y) 
      somme1=somme1+(FONCT_2D_c(x,y)*BASEC(nbr1))           
      
      INTEGRPQ_2D_c=somme1*ABS(det)     

      RETURN
      end


