c  Fichier permequi_c.f
c
c***********************************************************************
      subroutine PERMEAEQUI_C(aa1,aa2,aa3,ia1,ia2,ia3,ja1,ja2,ja3,
     @    X1,X2,X3,nti1,nti2,nti3,nnf1,nnf2,nnf3,volume,CONDB1,CONDB2,
     @        CONDB3,bb1,bb2,bb3,ib1,ib2,ib3,jb1,jb2,jb3,cc1,cc2,cc3,
     @      ic1,ic2,ic3,jc1,jc2,jc3,poroh,MOY,RESULTATS_MC,ig,nbgros)

c***********************************************************************
c
c       Cette procedure calcule le tenseur homogeneise a partir
c       des 3 solutions des problemes locauX1.
c

        implicit none

        integer   i,j,l,entier,k,m,kk,ig
        integer   nti1,nti2,nti3,nnf1,nnf2,nnf3
        integer   ia1,ia2,ia3,ib1,ib2,ib3,ic1,ic2,ic3
        integer   ja1,ja2,ja3,jb1,jb2,jb3,jc1,jc2,jc3
        integer   nbgros
        real*8    X1,X2,X3,somme1,somme2,somme3,volume,MOY,RESULTATS_MC
        real*8    K11,K22,K33,CONDB1,CONDB2,CONDB3,poroh
        real*8    aa1,aa2,aa3,bb1,bb2,bb3,cc1,cc2,cc3
        dimension X3(*),X2(*),X1(*)
        dimension aa1(*),aa2(*),aa3(*),bb1(*),bb2(*),bb3(*)
        dimension cc1(*),cc2(*),cc3(*),ia1(*),ia2(*),ia3(*)
        dimension ib1(*),ib2(*),ib3(*),ic1(*),ic2(*),ic3(*)
        dimension ja1(*),ja2(*),ja3(*),jb1(*),jb2(*),jb3(*)
        dimension jc1(*),jc2(*),jc3(*)
        dimension CONDB1(*),CONDB2(*),CONDB3(*)
        dimension MOY(*),RESULTATS_MC(nbgros,*)

c initialisation

        somme1=0.d0
        somme2=0.d0
        somme3=0.d0

       write(20,*)
       write(20,*)'1'
       write(20,*)'somme1',somme1
       write(20,*)'somme2',somme2
       write(20,*)'somme3',somme3

c contribution int-int

        m=1
        l=1
        do i=1,nti1
           do k=1,(ia1(m+1)-ia1(m))
              j=ja1(l)
              somme1=somme1+(X1(i)*X1(j)*aa1(l))
              l=l+1
           enddo
           m=m+1
        enddo
      
        m=2
        l=2
        do i=2,nti1
           do k=1,(ia1(m+1)-ia1(m)-1)
              j=ja1(l)
              somme1=somme1+(X1(j)*X1(i)*aa1(l))
              l=l+1
           enddo
           l=l+1
           m=m+1
        enddo
c **************
        m=1
        l=1
        do i=1,nti2
           do k=1,(ia2(m+1)-ia2(m))
              j=ja2(l)
              somme2=somme2+(X2(j)*X2(i)*aa2(l))
              l=l+1
           enddo
           m=m+1
        enddo

        m=2
        l=2
        do i=2,nti2
           do k=1,(ia2(m+1)-ia2(m)-1)
              j=ja2(l)
              somme2=somme2+(X2(j)*X2(i)*aa2(l))
              l=l+1
           enddo
           l=l+1
           m=m+1
        enddo
c*************
        m=1
        l=1
        do i=1,nti3
           do k=1,(ia3(m+1)-ia3(m))
              j=ja3(l)
              somme3=somme3+(X3(j)*X3(i)*aa3(l))
              l=l+1
           enddo
           m=m+1
        enddo

        m=2
        l=2
        do i=2,nti3
           do k=1,(ia3(m+1)-ia3(m)-1)
              j=ja3(l)
              somme3=somme3+(X3(j)*X3(i)*aa3(l))
              l=l+1
           enddo
           l=l+1
           m=m+1
        enddo

       write(20,*)
       write(20,*)'1'
       write(20,*)'somme1',somme1
       write(20,*)'somme2',somme2
       write(20,*)'somme3',somme3
c contribution bord-int

       kk=1
       do i=1,nnf1
          do j=1,ic1(i+1)-ic1(i)
              entier=jc1(kk)
                if (entier.le.nti1) then
                   somme1=somme1+(CONDB1(i)*cc1(kk)*X1(entier))
                endif
              kk=kk+1
          enddo
       enddo

       kk=1
       do i=1,nnf1
          do j=1,ic1(i+1)-ic1(i)
              entier=jc1(kk)
                if (entier.le.nti1) then
                   somme1=somme1+(CONDB1(i)*cc1(kk)*X1(entier))
                endif
              kk=kk+1
          enddo
       enddo
c********
       kk=1
       do i=1,nnf2
          do j=1,ic2(i+1)-ic2(i)
              entier=jc2(kk)
                if (entier.le.nti2) then
                   somme2=somme2+(CONDB2(i)*cc2(kk)*X2(entier))
                endif
              kk=kk+1
          enddo
       enddo

       kk=1
       do i=1,nnf2
          do j=1,ic2(i+1)-ic2(i)
              entier=jc2(kk)
                if (entier.le.nti2) then
                   somme2=somme2+(CONDB2(i)*cc2(kk)*X2(entier))
                endif
              kk=kk+1
          enddo
       enddo
c**********
       kk=1
       do i=1,nnf3
          do j=1,ic3(i+1)-ic3(i)
              entier=jc3(kk)
                if (entier.le.nti3) then
                   somme3=somme3+(CONDB3(i)*cc3(kk)*X3(entier))
                endif
              kk=kk+1
          enddo
       enddo

       kk=1
       do i=1,nnf3
          do j=1,ic3(i+1)-ic3(i)
              entier=jc3(kk)
                if (entier.le.nti3) then
                   somme3=somme3+(CONDB3(i)*cc3(kk)*X3(entier))
                endif
              kk=kk+1
          enddo
       enddo


       write(20,*)
       write(20,*)'1'
       write(20,*)'somme1',somme1
       write(20,*)'somme2',somme2
       write(20,*)'somme3',somme3
c contribution bord-bord

        m=1
        l=1
        do i=1,nnf1
           do k=1,(ib1(m+1)-ib1(m))
              j=jb1(l)
              somme1=somme1+(CONDB1(i)*CONDB1(j)*bb1(l))
              l=l+1
           enddo
           m=m+1
        enddo

        m=2
        l=2
        do i=2,nnf1
           do k=1,(ib1(m+1)-ib1(m)-1)
              j=jb1(l)
              somme1=somme1+(CONDB1(j)*CONDB1(i)*bb1(l))
              l=l+1
           enddo
           l=l+1
           m=m+1
        enddo
c********
        m=1
        l=1
        do i=1,nnf2
           do k=1,(ib2(m+1)-ib2(m))
              j=jb2(l)
              somme2=somme2+(CONDB2(i)*CONDB2(j)*bb2(l))
              l=l+1
           enddo
           m=m+1
        enddo

        m=2
        l=2
        do i=2,nnf2
           do k=1,(ib2(m+1)-ib2(m)-1)
              j=jb2(l)
              somme2=somme2+(CONDB2(j)*CONDB2(i)*bb2(l))
              l=l+1
           enddo
           l=l+1
           m=m+1
        enddo

c******
        m=1
        l=1
        do i=1,nnf3
           do k=1,(ib3(m+1)-ib3(m))
              j=jb3(l)
              somme3=somme3+(CONDB3(i)*CONDB3(j)*bb3(l))
              l=l+1
           enddo
           m=m+1
        enddo

        m=2
        l=2
        do i=2,nnf3
           do k=1,(ib3(m+1)-ib3(m)-1)
              j=jb3(l)
              somme3=somme3+(CONDB3(j)*CONDB3(i)*bb3(l))
              l=l+1
           enddo
           l=l+1
           m=m+1
        enddo
       write(20,*)
       write(20,*)'1'
       write(20,*)'somme1',somme1
       write(20,*)'somme2',somme2
       write(20,*)'somme3',somme3
       write(20,*)'volume',volume

c division par le volume le la grosse maille
      
      K11=somme1/volume
      K22=somme2/volume
      K33=somme3/volume
      poroh=poroh/volume
      do l=1,6
         MOY(l)=MOY(l)/volume
      enddo 

c calcul de la moyenne harmonique

      do l=4,6
         MOY(l)=1.d0/MOY(l) 
      enddo

c harmonisation des ecritures pour les resultats

      do l=1,6
           if (ABS(MOY(l)).le.1.d-05) then
                            MOY(l)=0.d0
           endif
      enddo

c ecritures des resultats

c      write(*,*)
c      write(*,19)
c      write(*,20)K11,K22,K33,poroh
c      write(20,*)
c      write(20,20)K11,K22,K33,poroh

c on affecte les resultats au tableau resultats

      RESULTATS_MC(ig,1)=K11
      RESULTATS_MC(ig,2)=K22
      RESULTATS_MC(ig,3)=K33
      RESULTATS_MC(ig,4)=poroh

c      write(*,19)
c      write(*,*)K11,K22,K33,poroh
c      write(17,*)

19    FORMAT(5x,'Kxx',8x,'Kyy',8x,'Kzz',8x,'PORO')
20    FORMAT(4(E11.4))

c      write(*,*)
c      write(*,30)
c      write(*,*)
c      write(*,40)MOY(1),MOY(2),MOY(3)
c      write(17,*)MOY(1),MOY(2),MOY(3),' ARITH'
c      write(*,*)
c      write(*,50)MOY(4),MOY(5),MOY(6)
c      write(17,*)MOY(4),MOY(5),MOY(6),' HARMO'
c      write(*,*)
c      write(17,*)
c      write(17,*)

30    FORMAT(5x,'Kxx',8x,'Kyy',8x,'Kzz')
40    FORMAT(3(E11.4),2x,'MOY ARITH')
50    FORMAT(3(E11.4),2x,'MOY HARMO')

      RETURN
      end
                                               
