c      Fichier prelimi22_2D_c.f
c
c******************************************************************
      subroutine PRELIMINAIRE22_2D_c(VECTF1,VECTF2,VECTI1,VECTI2,
     @           TABele,nnf1,nnf2,nti1,nti2,nte,
     @           ic1,ic2,nelemC1,nelemC2,VECT11,VECT12,
     @           ib1,ib2,nelemB1,nelemB2,
     @           ia1,ia2,nelemA1,nelemA2,
     @           MATB1,MATB2,MATC1,MATC2)
c*****************************************************************
c
c  Cette procedure affecte aux tableaux ia,ib,ic les valeurs definitives
c  en vue de l'assemblage des tableaux aa,bb et cc. Deplus les dimensions 
c  des tableaux aa,bb et cc sont calcules.
c
      implicit none

      integer   nte,i,j
      integer   VECTF1,VECTF2,VECTI1,VECTI2
      integer   nnf1,nnf2,nti1,nti2
      integer   ic1,ic2,nelemC1,nelemC2
      integer   VECT11,VECT12,ib1,ib2
      integer   nelemB1,nelemB2,ia1,ia2
      integer   nelemA1,nelemA2
      integer   l,ind
      integer   MATB1,MATB2,MATC1,MATC2
      integer   TABele,a,b,ivois,pos,nb
      dimension TABele(nte,*) 
      dimension MATB1(nnf1,*),MATB2(nnf2,*)
      dimension MATC1(nnf1,*),MATC2(nnf2,*)
      dimension VECTF1(*),VECTF2(*)
      dimension VECTI1(*),VECTI2(*)
      dimension ia1(*),ia2(*),ib1(*),ib2(*)
      dimension ic1(*),ic2(*),VECT11(*),VECT12(*)

       ind=1
       do i=1,nnf1
          l=1
          j=1
          do while (MATB1(i,l).ne.-1)
             l=l+1
          enddo
          do while (MATC1(i,j).ne.-1)
             nb=MATC1(i,j)-VECTF1(i)
             pos=1
             do while ((nb.ne.VECTI1(pos)).and.(pos.le.nti1)) 
                pos=pos+1
             enddo
             VECT11(ind)=pos
             ind=ind+1
             j=j+1
          enddo
          ib1(i)=l-1
          ic1(i)=j-1
          if (ic1(i).eq.0) then
             VECT11(ind)=0
             ind=ind+1
             ic1(i)=1
          endif
       enddo

       ind=1
       do i=1,nnf2
          l=1
          j=1
          do while (MATB2(i,l).ne.-1)
             l=l+1
          enddo
          do while (MATC2(i,j).ne.-1)
             nb=MATC2(i,j)-VECTF2(i)
             pos=1
             do while ((nb.ne.VECTI2(pos)).and.(pos.le.nti2))
                pos=pos+1
             enddo
             VECT12(ind)=pos
             ind=ind+1
             j=j+1
          enddo
          ib2(i)=l-1
          ic2(i)=j-1
          if (ic2(i).eq.0) then
             VECT12(ind)=0
             ind=ind+1
             ic2(i)=1
          endif
       enddo


c calcul du tableau ic final ainsi que nelemC

      a=ic1(1)
      ic1(1)=1
      do i=1,nnf1-1
         b=ic1(i+1)
         ic1(i+1)=ic1(i)+a
         a=b
      enddo
      ic1(nnf1+1)=ic1(nnf1)+a
      nelemC1=ic1(nnf1)+a-1

c      write(20,*)
c      write(20,*)'ic1 final'
c      do i=1,nnf1+1
c          write(20,*)ic1(i)
c      enddo
c      write(20,*)'nelemC1',nelemC1
c      write(20,*)'le veritable ord_gr1',nelemC1

      a=ic2(1)
      ic2(1)=1
      do i=1,nnf2-1
         b=ic2(i+1)
         ic2(i+1)=ic2(i)+a
         a=b
      enddo
      ic2(nnf2+1)=ic2(nnf2)+a
      nelemC2=ic2(nnf2)+a-1

c      write(20,*)
c      write(20,*)'ic2 final'
c      do i=1,nnf2+1
c          write(20,*)ic2(i)
c      enddo
c      write(20,*)'nelemC2',nelemC2
c      write(20,*)'le veritable ord_gr2',nelemC2

c calcul du tableau ib final ainsi que nelemB

      nelemB1=0
      do i=1,nnf1
         ivois=ib1(i)
         ib1(i)=nelemB1+1
         nelemB1=nelemB1+ivois+1
      enddo
      ib1(nnf1+1)=nelemB1+1

c      write(20,*)
c      write(20,*)'ib1 final'
c      do i=1,nnf1+1
c          write(20,*)ib1(i)
c      enddo
c      write(20,*)'nelemB1',nelemB1

      nelemB2=0
      do i=1,nnf2
         ivois=ib2(i)
         ib2(i)=nelemB2+1
         nelemB2=nelemB2+ivois+1
      enddo
      ib2(nnf2+1)=nelemB2+1

c      write(20,*)
c      write(20,*)'ib2 final'
c      do i=1,nnf2+1
c          write(20,*)ib2(i)
c      enddo
c      write(20,*)'nelemB2',nelemB2


c calcul du tableau ia final ainsi que nelemA

      nelemA1=0
      do i=1,nti1
         ivois=ia1(i)
         ia1(i)=nelemA1+1
         nelemA1=nelemA1+ivois+1
      enddo
      ia1(nti1+1)=nelemA1+1

c      write(20,*)
c      write(20,*)'ia1 final'
c      do i=1,nti1+1
c          write(20,*)i,ia1(i)
c      enddo
c      write(20,*)'nelemA1',nelemA1

      nelemA2=0
      do i=1,nti2
         ivois=ia2(i)
         ia2(i)=nelemA2+1
         nelemA2=nelemA2+ivois+1
      enddo
      ia2(nti2+1)=nelemA2+1

c      write(20,*)
c      write(20,*)'ia2 final'
c      do i=1,nti2+1
c          write(20,*)i,ia2(i)
c      enddo
c      write(20,*)'nelemA2',nelemA2


      RETURN
      end



