c  Fichier cont_hex_tot_c.f
c
c********************************************************************
      real*8 function CONTRIBUTION_C(GRAD1,GRAD2,GRAD3,GRAD4,GRAD5,
     @                 GRAD6,GRAD7,GRAD8,GRAD9,GRAD10,GRAD11,GRAD12,
     @                 GRAD13,GRAD14,det1,det2,det3,det4,det5,det6,
     @                 det7,det8,det9,det10,det11,det12,det13,det14,
     @                       K,nbr1,nbr2)           
c********************************************************************
c
c   
c   

      implicit none

      integer   nbr1,nbr2          
      real*8    s1,s2,a,b,c
      real*8    p1,p2,K
      dimension K(3,*)
      real*8    GRAD1,GRAD2,GRAD3,GRAD4,GRAD5,GRAD6,GRAD7,GRAD8
      real*8    GRAD9,GRAD10,GRAD11,GRAD12,GRAD13,GRAD14
      real*8    det1,det2,det3,det4,det5,det6,det7,det8
      real*8    det9,det10,det11,det12,det13,det14
      dimension GRAD1(8,*),GRAD2(8,*),GRAD3(8,*),GRAD4(8,*),GRAD5(8,*)
      dimension GRAD6(8,*),GRAD7(8,*),GRAD8(8,*),GRAD9(8,*),GRAD10(8,*)
      dimension GRAD11(8,*),GRAD12(8,*),GRAD13(8,*),GRAD14(8,*)

c points d'integration

      p1=(320.d0/361.d0)
      p2=(121.d0/361.d0)
      a=K(1,1) 
      b=K(2,2)
      c=K(3,3)

c integration numerique

      s1=(a*GRAD1(nbr1,1)*GRAD1(nbr2,1)+b*GRAD1(nbr1,2)*GRAD1(nbr2,2)
     @   +c*GRAD1(nbr1,3)*GRAD1(nbr2,3))*ABS(det1)
c      write(20,*)'GRAD',GRAD1(nbr1,1)
c      write(20,*)'s1',s1
      s1=(a*GRAD2(nbr1,1)*GRAD2(nbr2,1)+b*GRAD2(nbr1,2)*GRAD2(nbr2,2)
     @   +c*GRAD2(nbr1,3)*GRAD2(nbr2,3))*ABS(det2)+s1
c      write(20,*)'GRAD',GRAD1(nbr1,1)
c      write(20,*)'s1',s1
      s1=(a*GRAD3(nbr1,1)*GRAD3(nbr2,1)+b*GRAD3(nbr1,2)*GRAD3(nbr2,2)
     @   +c*GRAD3(nbr1,3)*GRAD3(nbr2,3))*ABS(det3)+s1
      s1=(a*GRAD4(nbr1,1)*GRAD4(nbr2,1)+b*GRAD4(nbr1,2)*GRAD4(nbr2,2)
     @   +c*GRAD4(nbr1,3)*GRAD4(nbr2,3))*ABS(det4)+s1
      s1=(a*GRAD5(nbr1,1)*GRAD5(nbr2,1)+b*GRAD5(nbr1,2)*GRAD5(nbr2,2)
     @   +c*GRAD5(nbr1,3)*GRAD5(nbr2,3))*ABS(det5)+s1
      s1=((a*GRAD6(nbr1,1)*GRAD6(nbr2,1)+b*GRAD6(nbr1,2)*GRAD6(nbr2,2)
     @   +c*GRAD6(nbr1,3)*GRAD6(nbr2,3))*ABS(det6)+s1)*p1

      s2=(a*GRAD7(nbr1,1)*GRAD7(nbr2,1)+b*GRAD7(nbr1,2)*GRAD7(nbr2,2)
     @   +c*GRAD7(nbr1,3)*GRAD7(nbr2,3))*ABS(det7)
      s2=(a*GRAD8(nbr1,1)*GRAD8(nbr2,1)+b*GRAD8(nbr1,2)*GRAD8(nbr2,2)
     @   +c*GRAD8(nbr1,3)*GRAD8(nbr2,3))*ABS(det8)+s2
      s2=(a*GRAD9(nbr1,1)*GRAD9(nbr2,1)+b*GRAD9(nbr1,2)*GRAD9(nbr2,2)
     @   +c*GRAD9(nbr1,3)*GRAD9(nbr2,3))*ABS(det9)+s2
      s2=(a*GRAD10(nbr1,1)*GRAD10(nbr2,1)+b*GRAD10(nbr1,2)*
     @  GRAD10(nbr2,2)+c*GRAD10(nbr1,3)*GRAD10(nbr2,3))*ABS(det10)+s2
      s2=(a*GRAD11(nbr1,1)*GRAD11(nbr2,1)+b*GRAD11(nbr1,2)*
     @  GRAD11(nbr2,2)+c*GRAD11(nbr1,3)*GRAD11(nbr2,3))*ABS(det11)+s2
      s2=(a*GRAD12(nbr1,1)*GRAD12(nbr2,1)+b*GRAD12(nbr1,2)*
     @  GRAD12(nbr2,2)+c*GRAD12(nbr1,3)*GRAD12(nbr2,3))*ABS(det12)+s2
      s2=(a*GRAD13(nbr1,1)*GRAD13(nbr2,1)+b*GRAD13(nbr1,2)*
     @  GRAD13(nbr2,2)+c*GRAD13(nbr1,3)*GRAD13(nbr2,3))*ABS(det13)+s2
      s2=((a*GRAD14(nbr1,1)*GRAD14(nbr2,1)+b*GRAD14(nbr1,2)*
     @ GRAD14(nbr2,2)+c*GRAD14(nbr1,3)*GRAD14(nbr2,3))*ABS(det14)+s2)
     @ *p2

      
      CONTRIBUTION_C=s1+s2     

      RETURN
      end


