c  Fichier cont_hex_tot_c.f
c
c********************************************************************
      real*8 function CONTRIBUTION_C(GRAD1,GRAD2,GRAD3,GRAD4,GRAD5,
     @                 GRAD6,GRAD7,GRAD8,GRAD9,GRAD10,GRAD11,GRAD12,
     @                 GRAD13,GRAD14,det1,det2,det3,det4,det5,det6,
     @                 det7,det8,det9,det10,det11,det12,det13,det14,
     @                       K,nbr1,nbr2)           
c********************************************************************
c
c   
c   

      implicit none

      integer   nbr1,nbr2          
      real*8    somme1,somme2
      real*8    p1,p2,K,PRODUIT_TOT_C
      dimension K(3,*)
      real*8    GRAD1,GRAD2,GRAD3,GRAD4,GRAD5,GRAD6,GRAD7,GRAD8
      real*8    GRAD9,GRAD10,GRAD11,GRAD12,GRAD13,GRAD14
      real*8    det1,det2,det3,det4,det5,det6,det7,det8
      real*8    det9,det10,det11,det12,det13,det14
      dimension GRAD1(8,*),GRAD2(8,*),GRAD3(8,*),GRAD4(8,*),GRAD5(8,*)
      dimension GRAD6(8,*),GRAD7(8,*),GRAD8(8,*),GRAD9(8,*),GRAD10(8,*)
      dimension GRAD11(8,*),GRAD12(8,*),GRAD13(8,*),GRAD14(8,*)

c points d'integration

      p1=(320.d0/361.d0)
      p2=(121.d0/361.d0)

c integration numerique

      
      somme1=PRODUIT_TOT_C(K,GRAD1,nbr1,nbr2)*ABS(det1)
      somme1=somme1+PRODUIT_TOT_C(K,GRAD2,nbr1,nbr2)*ABS(det2)
      somme1=somme1+PRODUIT_TOT_C(K,GRAD3,nbr1,nbr2)*ABS(det3)
      somme1=somme1+PRODUIT_TOT_C(K,GRAD4,nbr1,nbr2)*ABS(det4)
      somme1=somme1+PRODUIT_TOT_C(K,GRAD5,nbr1,nbr2)*ABS(det5)
      somme1=(somme1+PRODUIT_TOT_C(K,GRAD6,nbr1,nbr2)*ABS(det6))*p1

      somme2=PRODUIT_TOT_C(K,GRAD7,nbr1,nbr2)*ABS(det7)
      somme2=somme2+PRODUIT_TOT_C(K,GRAD8,nbr1,nbr2)*ABS(det8)
      somme2=somme2+PRODUIT_TOT_C(K,GRAD9,nbr1,nbr2)*ABS(det9)
      somme2=somme2+PRODUIT_TOT_C(K,GRAD10,nbr1,nbr2)*ABS(det10)
      somme2=somme2+PRODUIT_TOT_C(K,GRAD11,nbr1,nbr2)*ABS(det11)
      somme2=somme2+PRODUIT_TOT_C(K,GRAD12,nbr1,nbr2)*ABS(det12)
      somme2=somme2+PRODUIT_TOT_C(K,GRAD13,nbr1,nbr2)*ABS(det13)
      somme2=(somme2+PRODUIT_TOT_C(K,GRAD14,nbr1,nbr2)*ABS(det14))*p2
      
      CONTRIBUTION_C=somme1+somme2     

      RETURN
      end


