c
c   this common block contains some physical constants for use in the
c simulator.
c
      common /constants/ gravity,drgrvty(3)
c
c pressure units
c
c   prsunits - the units for the pressure variables
c   prslenunits - the units for the length variables
c   prstimeunits - the units for the time variable
c   prsinjectunits - the units for the injection
c   prspermunits - the units for the permeability variables
c   prsdensunits - the units for the density variables
c   prsgravityunits - the units for the gravity variables
c   prsviscunits - the units for the viscosity variables
c
c temporary kludge
c
c   prsunitsconv
c      prsunitsconv = 86400.
c      prsunitsconv = 384.7824
c      prsunitsconv = 1.0
c      prsunitsconv = .0013840046
c
c
     1,prsunits,prslenunits,prstimeunits
     1,prsinjectunits,prspermunits,prsdensunits,prsgravityunits
     1,prsviscunits,prsunitsconv
c
c conversion factors to use in the simulator
c
c   timefactor - the time scaling constant to use on the input
c   permfactor - the permeability scaling constant to use on the input
c
     1,timefactor,permfactor
c
      character*40 prsunits,prslenunits,prstimeunits,prsinjectunits
     1,prspermunits,prsdensunits,prsgravityunits,prsviscunits

