*** fichier remplissage_maa.f

      subroutine remplissage_maa (i,j,ia,ja,bool,empl,prem)
      
      implicit none

*  i : indice de la ligne pour la matrice de discretisation
*  j : indice de la colonne pour la matrice de discretisation
* ia : vecteur contenant la position dans a des premiers elements non nuls de chaque ligne
* ja : vecteur contenat les colonnes de chaque element de a
* bool : booleen qui prend 1 si l'element A(i,j) a deja ete implemente et 0 sinon
* empl : donne la place de l'element dans ja (et donc dans aa qui contient les elements non nuls de la matrice de discretisation) QUAND bool = 1
* prem : donne le premier emplacement vide dans le vecteur ja QUAND bool = 0


      integer ia(*),ja(*)
      integer i,j,empl,bool,prem,k

      bool=0
      prem=0
      k=ia(i) 

*     boucle tant que
   1  if ((bool .eq. 0) .and. (k .le. (ia(i+1)-2))) then

*       si element a deja implemente
	if (ja(k) .eq. j) then
           bool=1
	   k=k-1
        end if

*	si element non encore implemente : determination du premier emplacement libre
        if ((bool .eq. 0) .and. (ja(k).eq. 0) .and.
     *       ((prem .gt. k) .or.(prem .eq. 0))) then
           prem=k
        end if

        k=k+1
        go to 1
      endif  
*     fin boucle tant que

      empl=k

      return
      end
      







