**************************************************************
********                     tri.f                      ******

*
* Ce sous-programme est ecrit sous forme tres compacte
* ce qui le rend difficile a la comprehension.
*
* Il s'agit de ranger les elements du tableau criter
* par ordre croissant d"indices et de modifier 
* simultanement les elements du tableau record.
*
*
*	de 'INTRODUCTION AU CALCUL SCIENTIFIQUE' 
*	B. LUCQUIN
*	O. PIRONNEAU
*	MASSON, 1996


      subroutine Tri(criter,record,n)
      
      implicit none
 
* n : nombre d'elements a ranger
* criter : vecteur contenant les indices des colonnes des elements contenus dans record
* record : vecteur contenant les elements de la matrice de discretisation
     
      integer n
      integer crit,criter(n)
      real record(n),rec
      integer l,r,j,i
      
      if (n .le. 1) then
         return
      end if
      l=n/2+1
      r=n

 2    if (l .gt. 1) then
         l=l-1
         rec=record(l)
         crit=criter(l)
      else
         rec=record(r)
         crit=criter(r)
         record(r)=record(1)
         criter(r)=criter(1)
         r=r-1
         if (r .eq. 1) then
            record(1)=rec
            criter(1)=crit
            return
         end if
      end if

 3    j=l
 4    i=j
      j=j*2
      if (j-r .lt. 0) then
         goto 5
      elseif (j .eq.r) then
         goto 6
      else 
         goto 8
      end if
 5    if (criter(j) .lt. criter(j+1)) j=j+1
 6    if (crit .ge. criter(j)) goto 8
      record(i)=record(j)
      criter(i)=criter(j)
      goto 4
 8    record(i)=rec
      criter(i)=crit
      goto 2

      end
      











