c      Fichier prelimi21_c.f
c
c******************************************************************
      subroutine PRELIMINAIRE21_C(VECTF1,VECTF2,VECTF3,VECTI1,VECTI2,
     @  VECTI3,TABele,nnf1,nnf2,nnf3,nti1,nti2,nti3,nte,ia1,ia2,ia3,
     @        MATA1,MATA2,MATA3,MATB1,MATB2,MATB3,MATC1,MATC2,MATC3,
     @ ord_gr1,ord_gr2,ord_gr3,lb,TABnoeud1,TABnoeud2,TABnoeud3,ntn)
c*****************************************************************
c
c  Cette procedure affecte aux tableaux ia,ib,ic les valeurs definitives
c  en vue de l'assemblage des tableaux aa,bb et cc. Deplus les dimensions 
c  des tableaux aa,bb et cc sont calcules.
c
      implicit none

      integer   nte,i,j,entIF1,entIF2,entIF3,deb,pos11,pos12,pos13
      integer   pos21,pos22,pos23,INDICE1,INDICE2,INDICE3,ntn
      integer   VECTF1,VECTF2,VECTF3,VECTI1,VECTI2,VECTI3
      integer   ord_gr1,ord_gr2,ord_gr3
      integer   k,lb,nbndele,l,entIV1,entIV2,entIV3,ind
      integer   TABele,ia1,ia2,ia3,m,nb1,nb2,nb3
      integer   nnf1,nnf2,nnf3,nti1,nti2,nti3
      integer   dec,MATA1,MATA2,MATA3,MATB1,MATB2,MATB3
      integer   MATC1,MATC2,MATC3
      real*8    TABnoeud1,TABnoeud2,TABnoeud3
      logical   elementbis1,elementbis2,elementbis3
      dimension MATA1(nti1,*),MATA2(nti2,*),MATA3(nti3,*)
      dimension MATB1(nnf1,*),MATB2(nnf2,*),MATB3(nnf3,*)
      dimension MATC1(nnf1,*),MATC2(nnf2,*),MATC3(nnf3,*)
      dimension INDICE1(9),INDICE2(9),INDICE3(9)
      dimension elementbis1(9),elementbis2(9),elementbis3(9)
      dimension ia1(*),ia2(*),ia3(*),VECTF1(*),VECTF2(*),VECTF3(*)
      dimension VECTI1(*),VECTI2(*),VECTI3(*)
      dimension TABele(nte,*) 
      dimension TABnoeud1(ntn,*),TABnoeud2(ntn,*),TABnoeud3(ntn,*)


c initialisation des tableaux  MATA,MATB,MATC 

      do j=1,lb
         do i=1,nti1
            MATA1(i,j)=-1
         enddo
         do i=1,nti2
            MATA2(i,j)=-1
         enddo
         do i=1,nti3
            MATA3(i,j)=-1
         enddo
         do i=1,nnf1
            MATB1(i,j)=-1
            MATC1(i,j)=-1
         enddo
         do i=1,nnf2
            MATB2(i,j)=-1
            MATC2(i,j)=-1
         enddo
         do i=1,nnf3
            MATB3(i,j)=-1
            MATC3(i,j)=-1
         enddo
      enddo

      nb1=1
      nb2=1
      nb3=1
      ind=1
      do k=1,nte
         do j=2,9
            INDICE1(j)=TABnoeud1(TABele(k,j),5)
            INDICE2(j)=TABnoeud2(TABele(k,j),5)
            INDICE3(j)=TABnoeud3(TABele(k,j),5)
            if (TABnoeud1(TABele(k,j),4).eq.0) then
                elementbis1(j)=.false.
                                               else
                elementbis1(j)=.true. 
            endif
            if (TABnoeud2(TABele(k,j),4).eq.0) then
                elementbis2(j)=.false.
                                               else
                elementbis2(j)=.true. 
            endif
            if (TABnoeud3(TABele(k,j),4).eq.0) then
                elementbis3(j)=.false.
                                               else
                elementbis3(j)=.true. 
            endif
         enddo
         nbndele=9

c         write(20,*)
c         write(20,*)'element',k
c         write(20,*)(TABele(k,j),j=1,9)
c         write(20,*)(elementbis1(j),j=1,9)
c         write(20,*)(INDICE1(j),j=1,9)
c         write(20,*)'nbndele',nbndele
         do j=2,(nbndele-1)
                deb=j+1
                pos11=INDICE1(j)
                entIF1=TABele(k,j)
                if (elementbis1(j)) then
                    do m=deb,nbndele
                    call DECALAGE_C(m,nbndele,dec)
                       entIV1=TABele(k,dec)
                       pos21=INDICE1(m)
                       if (elementbis1(m)) then
                           if (entIV1.lt.entIF1) then
c                       write(20,*)'MATA1'
                    call RANGEMENT_C(MATA1,pos11,entIF1,entIV1,lb,nti1) 
                                               else
c                       write(20,*)'MATA1'
                    call RANGEMENT_C(MATA1,pos21,entIF1,entIV1,lb,nti1)
                           endif
                                          else
c                       write(20,*)'MATC1'
                    call RANGEMENT_C(MATC1,pos21,entIF1,entIV1,lb,nnf1)
                           nb1=nb1+1
                       endif
                    enddo
                                    else
                    do m=deb,nbndele
                    call DECALAGE_C(m,nbndele,dec)
                       entIV1=TABele(k,dec)
                       pos21=INDICE1(m)
                       if (.not.(elementbis1(m))) then
                           if (entIV1.lt.entIF1) then
c                       write(20,*)'MATB1'
                    call RANGEMENT_C(MATB1,pos11,entIF1,entIV1,lb,nnf1)
                                               else
c                       write(20,*)'MATB1'
                    call RANGEMENT_C(MATB1,pos21,entIF1,entIV1,lb,nnf1)
                           endif
                                                 else
c                       write(20,*)'MATC1'
                    call RANGEMENT_C(MATC1,pos11,entIF1,entIV1,lb,nnf1)
                           nb1=nb1+1
                       endif
                    enddo
                endif
           enddo 

c         write(20,*)(elementbis2(j),j=1,9)
c         write(20,*)(INDICE2(j),j=1,9)
c         write(20,*)'nbndele',nbndele
         do j=2,(nbndele-1)
                deb=j+1
                pos12=INDICE2(j)
                entIF2=TABele(k,j)
                if (elementbis2(j)) then
                    do m=deb,nbndele
                    call DECALAGE_C(m,nbndele,dec)
                       entIV2=TABele(k,dec)
                       pos22=INDICE2(m)
                       if (elementbis2(m)) then
                           if (entIV2.lt.entIF2) then
c                       write(20,*)'MATA2'
                    call RANGEMENT_C(MATA2,pos12,entIF2,entIV2,lb,nti2)
                                               else
c                       write(20,*)'MATA2'
                    call RANGEMENT_C(MATA2,pos22,entIF2,entIV2,lb,nti2)
                           endif
                                          else
c                       write(20,*)'MATC2'
                    call RANGEMENT_C(MATC2,pos22,entIF2,entIV2,lb,nnf2)
                           nb2=nb2+1
                       endif
                    enddo
                                    else
                    do m=deb,nbndele
                    call DECALAGE_C(m,nbndele,dec)
                       entIV2=TABele(k,dec)
                       pos22=INDICE2(m)
                       if (.not.(elementbis2(m))) then
                           if (entIV2.lt.entIF2) then
c                       write(20,*)'MATB2'
                    call RANGEMENT_C(MATB2,pos12,entIF2,entIV2,lb,nnf2)
                                               else
c                       write(20,*)'MATB2'
                    call RANGEMENT_C(MATB2,pos22,entIF2,entIV2,lb,nnf2)
                           endif
                                                 else
c                       write(20,*)'MATC2'
                    call RANGEMENT_C(MATC2,pos12,entIF2,entIV2,lb,nnf2)
                           nb2=nb2+1
                       endif
                    enddo
                endif
           enddo

c         write(20,*)(elementbis3(j),j=1,9)
c         write(20,*)(INDICE3(j),j=1,9)
c         write(20,*)'nbndele',nbndele
         do j=2,(nbndele-1)
                deb=j+1
                pos13=INDICE3(j)
                entIF3=TABele(k,j)
                if (elementbis3(j)) then
                    do m=deb,nbndele
                    call DECALAGE_C(m,nbndele,dec)
                       entIV3=TABele(k,dec)
                       pos23=INDICE3(m)
                       if (elementbis3(m)) then
                           if (entIV3.lt.entIF3) then
c                       write(20,*)'MATA3'
                    call RANGEMENT_C(MATA3,pos13,entIF3,entIV3,lb,nti3)
                                               else
c                       write(20,*)'MATA3'
                    call RANGEMENT_C(MATA3,pos23,entIF3,entIV3,lb,nti3)
                           endif
                                          else
c                       write(20,*)'MATC3'
                    call RANGEMENT_C(MATC3,pos23,entIF3,entIV3,lb,nnf3)
                           nb3=nb3+1
                       endif
                    enddo
                                    else
                    do m=deb,nbndele
                    call DECALAGE_C(m,nbndele,dec)
                       entIV3=TABele(k,dec)
                       pos23=INDICE3(m)
                       if (.not.(elementbis3(m))) then
                           if (entIV3.lt.entIF3) then
c                       write(20,*)'MATB3'
                    call RANGEMENT_C(MATB3,pos13,entIF3,entIV3,lb,nnf3)
                                               else
c                       write(20,*)'MATB3'
                    call RANGEMENT_C(MATB3,pos23,entIF3,entIV3,lb,nnf3)
                           endif
                                                 else
c                       write(20,*)'MATC3'
                    call RANGEMENT_C(MATC3,pos13,entIF3,entIV3,lb,nnf3)
                           nb3=nb3+1
                       endif
                    enddo
                endif
           enddo

       enddo      


c                write(20,*)'***********************'
c                do iii=1,nti1
c                   write(20,*)'MATA1',(MATA1(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATB1',(MATB1(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATC1',(MATC1(iii,jjj),jjj=1,lb)
c                enddo
c                write(20,*)'***********************'

c                write(20,*)'***********************'
c                do iii=1,nti1
c                   write(20,*)'MATA2',(MATA2(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATB2',(MATB2(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATC2',(MATC2(iii,jjj),jjj=1,lb)
c                enddo
c                write(20,*)'***********************'

c                write(20,*)'***********************'
c                do iii=1,nti1
c                   write(20,*)'MATA3',(MATA3(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATB3',(MATB3(iii,jjj),jjj=1,lb)
c                enddo
c                   write(20,*)
c                do iii=1,nnf1
c                   write(20,*)'MATC3',(MATC3(iii,jjj),jjj=1,lb)
c                enddo
c                write(20,*)'***********************'
                    
       do i=1,nti1
          l=1
          do while (MATA1(i,l).ne.-1) 
             l=l+1
          enddo
          ia1(i)=l-1
c          write(20,*)i,' ia1',ia1(i)
       enddo
c          write(20,*)
       do i=1,nti2
          l=1
          do while (MATA2(i,l).ne.-1)
             l=l+1
          enddo
          ia2(i)=l-1
c          write(20,*)i,' ia2',ia2(i)
       enddo
c          write(20,*)
       do i=1,nti3
          l=1
          do while (MATA3(i,l).ne.-1)
             l=l+1
          enddo
          ia3(i)=l-1
c          write(20,*)i,' ia3',ia3(i)
       enddo

       ord_gr1=nb1+nnf1+100
       ord_gr2=nb2+nnf2+100
       ord_gr3=nb3+nnf3+100

c       write(20,*)'nouvel ord-gr1',ord_gr1 
c       write(20,*)'nouvel ord-gr2',ord_gr2
c       write(20,*)'nouvel ord-gr3',ord_gr3

       RETURN
       end





c*****************************************************************
       subroutine RANGEMENT_C(MATA,pos,entIF,entIV,lb,borne)
c*****************************************************************
c
c
       implicit none
       integer MATA,l,lb,pos,entIF,entIV,borne

       dimension MATA(borne,*)

       l=1
       do while (l.le.lb)
          if (MATA(pos,l).ne.entIF+entIV) then      
              if (MATA(pos,l).eq.-1) then
                  MATA(pos,l)=entIF+entIV
c                  write(20,*)'MAT',(MATA(pos,k),k=1,100)
                  RETURN
                                     else
                  l=l+1
              endif
                                          else
              RETURN
          endif
       enddo
       
       RETURN
       end


c*****************************************************************
       subroutine DECALAGE_C(j,nbndele,dec)
c****************************************************************
c
c
       implicit none
       integer j,nbndele,dec

       if ((j.eq.5).and.(nbndele.eq.5)) then
          dec=j+1
             else
          dec=j
       endif

       RETURN
       end



