c
c  Fichier th3D_EFC_C.f
c
c**********************************************************************
c               FICHIERS NECESSAIRES AU PROGRAMME PRINCIPAL
c**********************************************************************
c
      INCLUDE'BIB/permequi_c.f'
      INCLUDE'BIB/nfr_nint1_c.f'
      INCLUDE'BIB/2nd_memb_c.f'
      INCLUDE'BIB/ecr_vect_c.f'
c      INCLUDE'BIB/hexa_c.f'
      INCLUDE'BIB/TOT/hexa_tot_c.f' ! idem que hexa_c.f mais + vite
      INCLUDE'BIB/mise_a_0_c.f'
      INCLUDE'BIB/assemb_a_c.f'
      INCLUDE'BIB/prelimi21_c.f'
      INCLUDE'BIB/prelimi22_c.f'
      INCLUDE'BIB/assemb_c_c.f'
      INCLUDE'BIB/tri_c.f'
      INCLUDE'BIB/icholes_c.f'
      INCLUDE'BIB/gradcp_c.f'
      INCLUDE'BIB/fonct_2m_c.f'
      INCLUDE'BIB/jc_c.f'
      INCLUDE'module_2D_NC_c.f'

c****************************************************************
c****************************************************************        
      
       subroutine th3D_EFC_C(ig,itag,nbgros,nbtam,RESULTATS_MC,LIGNE1,
     @           LIGNEia1,LIGNEib1,LIGNEic1,LIGNEjc1,LIGNEcc1,
     @           LIGNEia2,LIGNEib2,LIGNEic2,LIGNEjc2,LIGNEcc2,
     @           LIGNEia3,LIGNEib3,LIGNEic3,LIGNEjc3,LIGNEcc3,
     @           ntn,nte,nti,nnf,nti1,nti2,nti3,MaMO,taille,
     @           TABele,PETRO,COORD_POS)

c****************************************************************
c*auteur   Thierry Hontans 
c*auteur   Docteur en mathematiques appliquees
c****************************************************************        
c*ver     version du 01/03/99
c****************************************************************        

c    Ce programme calcule un tenseur homogeneise suivant la
c    methode du mode confine

      implicit none

      integer i,j,chele,ntn,ord_gr1,ord_gr2,ord_gr3,nte,nbgros
      integer nti1,nti2,nti3,nnf1,nnf2,nnf3,err,MaMO,nti,nnf,max
      integer lb,kmax,ig,igk,nbtam,itag  !,st1,st2
      integer nelemA1,nelemA2,nelemA3,taille
      integer nelemB1,nelemB2,nelemB3
      integer nelemC1,nelemC2,nelemC3
      integer INDICE1,INDICE2,INDICE3,TABele(nte,*)
      logical bo1,bo2,bo3,bo4,bo5,bo6
      real*8  K,N1,N2,N3,N4,N5,N6,N7,N8,eps,PETRO(nte,*)
      real*8  poro,poroh1,MOY1,poroh2,MOY2,poroh3,MOY3
      real*8  volume1,volume2,volume3,x_min,y_min,z_min
      real*8  RESULTATS_MC(nbgros,*),COORD_POS(ntn,*)
      integer LIGNE1(nbtam,*)
      logical ELEMENTBIS1,ELEMENTBIS2,ELEMENTBIS3
      character*12 name

      parameter (lb=100) !on peut descendre a 30 ( a verifier )

      dimension N1(4),N2(4),N3(4),N4(4),N5(4),N6(4),N7(4),N8(4)
      dimension K(3,3),MOY1(9),MOY2(9),MOY3(9)
      dimension ELEMENTBIS1(9),ELEMENTBIS2(9),ELEMENTBIS3(9)
      dimension INDICE1(9),INDICE2(9),INDICE3(9)
      
      integer  LIGNEia1(nbtam,*),LIGNEib1(nbtam,*),LIGNEic1(nbtam,*)
      integer  LIGNEjc1(nbtam,*)
      integer  LIGNEia2(nbtam,*),LIGNEib2(nbtam,*),LIGNEic2(nbtam,*)
      integer  LIGNEjc2(nbtam,*)
      integer  LIGNEia3(nbtam,*),LIGNEib3(nbtam,*),LIGNEic3(nbtam,*)
      integer  LIGNEjc3(nbtam,*)
      real*8   LIGNEcc1(nbtam,*),LIGNEcc2(nbtam,*),LIGNEcc3(nbtam,*)

      integer VECTI1(:)
      ALLOCATABLE VECTI1
      integer VECTI2(:)
      ALLOCATABLE VECTI2
      integer VECTI3(:)
      ALLOCATABLE VECTI3
      integer VECTF1(:)
      ALLOCATABLE VECTF1
      integer VECTF2(:)
      ALLOCATABLE VECTF2
      integer VECTF3(:)
      ALLOCATABLE VECTF3
      integer ia1(:)
      ALLOCATABLE ia1
      integer ia2(:)
      ALLOCATABLE ia2
      integer ia3(:)
      ALLOCATABLE ia3
      integer ja1(:)
      ALLOCATABLE ja1
      integer ja2(:)
      ALLOCATABLE ja2 
      integer ja3(:)
      ALLOCATABLE ja3
      integer ib1(:)
      ALLOCATABLE ib1
      integer ib2(:)
      ALLOCATABLE ib2
      integer ib3(:)
      ALLOCATABLE ib3
      integer jb1(:)
      ALLOCATABLE jb1
      integer jb2(:)
      ALLOCATABLE jb2
      integer jb3(:)
      ALLOCATABLE jb3
      integer ic1(:)
      ALLOCATABLE ic1
      integer ic2(:)
      ALLOCATABLE ic2
      integer ic3(:)
      ALLOCATABLE ic3
      integer jc1(:)
      ALLOCATABLE jc1
      integer jc2(:)
      ALLOCATABLE jc2
      integer jc3(:)
      ALLOCATABLE jc3
      integer VECT11(:)
      ALLOCATABLE VECT11
      integer VECT12(:)
      ALLOCATABLE VECT12
      integer VECT13(:)
      ALLOCATABLE VECT13
      integer MATA1(:,:)
      ALLOCATABLE MATA1
      integer MATA2(:,:)
      ALLOCATABLE MATA2
      integer MATA3(:,:)
      ALLOCATABLE MATA3
      integer MATB1(:,:)
      ALLOCATABLE MATB1
      integer MATB2(:,:)
      ALLOCATABLE MATB2
      integer MATB3(:,:)
      ALLOCATABLE MATB3
      integer MATC1(:,:)
      ALLOCATABLE MATC1
      integer MATC2(:,:)
      ALLOCATABLE MATC2
      integer MATC3(:,:)
      ALLOCATABLE MATC3

      real*8 TABnoeud1(:,:)
      ALLOCATABLE TABnoeud1
      real*8 TABnoeud2(:,:)
      ALLOCATABLE TABnoeud2
      real*8 TABnoeud3(:,:)
      ALLOCATABLE TABnoeud3

      real*8 SMinter1(:)
      ALLOCATABLE SMinter1
      real*8 SMinter2(:)
      ALLOCATABLE SMinter2
      real*8 SMinter3(:)
      ALLOCATABLE SMinter3
      real*8 SM1(:)
      ALLOCATABLE SM1
      real*8 SM2(:)
      ALLOCATABLE SM2
      real*8 SM3(:)
      ALLOCATABLE SM3
      real*8 X1(:)
      ALLOCATABLE X1
      real*8 X2(:)
      ALLOCATABLE X2
      real*8 X3(:)
      ALLOCATABLE X3
      real*8 CONDB1(:)
      ALLOCATABLE CONDB1
      real*8 CONDB2(:)
      ALLOCATABLE CONDB2
      real*8 CONDB3(:)
      ALLOCATABLE CONDB3
      real*8 aa1(:)
      ALLOCATABLE aa1
      real*8 aa2(:)
      ALLOCATABLE aa2
      real*8 aa3(:)
      ALLOCATABLE aa3

      real*8 al1(:)
      ALLOCATABLE al1
      real*8 al2(:)
      ALLOCATABLE al2
      real*8 al3(:)
      ALLOCATABLE al3
      real*8 bb1(:)
      ALLOCATABLE bb1
      real*8 bb2(:)
      ALLOCATABLE bb2
      real*8 bb3(:)
      ALLOCATABLE bb3
      real*8 cc1(:)
      ALLOCATABLE cc1
      real*8 cc2(:)
      ALLOCATABLE cc2
      real*8 cc3(:)
      ALLOCATABLE cc3
      real*8 gg(:)
      ALLOCATABLE gg
      real*8 h(:)
      ALLOCATABLE h  
      real*8 cg(:)
      ALLOCATABLE cg

      DATA kmax/500/
      DATA eps/1.d-05/

c debut du programme

c boucle sur les grosse maille

c      write(*,*)'debut du prog'

      igk=1
      bo1=.true.
      bo2=.true.
      bo3=.true.
      bo4=.true.
      bo5=.true.
      bo6=.true.

      name='data'

c Ouverture du  fichier de donnes et d'un fichier temporaire

      open(16,STATUS='SCRATCH',FORM='UNFORMATTED'
     @              ,ACCESS='DIRECT',RECL=32)


c      write(*,*)'***********************************************'
c      write(*,*)
c      write(*,*)'LECTURE DU MAILLAGE'

c on lit le nombre total de noeud et le nombre total d'element du maillage
c plus le nombre d'inconues et le nombre de noeud frontalier 


      nnf1=ntn-nti1
      nnf2=ntn-nti2
      nnf3=ntn-nti3
      write(20,*)ntn,nte,nti1,nti2,nti3,nnf1,nnf2,nnf3
c      write(*,*)ntn,nte,nti1,nti2,nti3,nnf1,nnf2,nnf3


c on fait une translation pour avoir de petit nombre a
c manipuler

      x_min=COORD_POS(1,2)
      y_min=COORD_POS(1,3)
      z_min=COORD_POS(1,4)
      write(20,*)'x_min',x_min,'y_min=',y_min,' z_min=',z_min
      do j=2,ntn
         if (COORD_POS(j,2).lt.x_min) then
             x_min=COORD_POS(j,2)
             write(20,*)'x_min',x_min
         endif
         if (COORD_POS(j,3).lt.y_min) then
             y_min=COORD_POS(j,3)
             write(20,*)'y_min=',y_min
         endif
         if (COORD_POS(j,4).lt.z_min) then
             z_min=COORD_POS(j,4)
             write(20,*)'z_min',z_min
         endif
      enddo
      write(20,*)'x_min',x_min,'y_min=',y_min,' z_min=',z_min
      do j=1,ntn
         COORD_POS(j,2)=COORD_POS(j,2)-x_min          
         COORD_POS(j,3)=COORD_POS(j,3)-y_min
         COORD_POS(j,4)=COORD_POS(j,4)-z_min
      enddo


c allocation dynamique de memoire des tableaux 

      ALLOCATE (VECTI1(nti1))
      ALLOCATE (VECTI2(nti2))
      ALLOCATE (VECTI3(nti3))
      ALLOCATE (VECTF1(nnf1))
      ALLOCATE (VECTF2(nnf2))
      ALLOCATE (VECTF3(nnf3))
      ALLOCATE (TABnoeud1(ntn,9))
      ALLOCATE (TABnoeud2(ntn,9))
      ALLOCATE (TABnoeud3(ntn,9))

c on range les elements du maillage dans le tableau TABele
c ainsi que la valeur de la permeabilite et de la porosite
c de l'element considere

c      write(*,*)'Rangements des elements du maillage dans un tableaux.'
      do i=1,nte
         write(20,*)(TABele(i,j),j=1,9),(PETRO(i,j),j=1,4)
      enddo

      do i=1,ntn
         write(20,*)(COORD_POS(i,j),j=1,8)                    
      enddo

c Si le nombre d'element de la maille grossiere vaut un
c on ecrit par defaut la petrophysique dans le tableau RESULTATS

      if (nte.eq.1) then
         RESULTATS_MC(ig,1)=PETRO(1,1)
         RESULTATS_MC(ig,2)=PETRO(1,2)
         RESULTATS_MC(ig,3)=PETRO(1,3)
         RESULTATS_MC(ig,4)=PETRO(1,4)
         DEALLOCATE (VECTI1)
         DEALLOCATE (VECTI2)
         DEALLOCATE (VECTI3)
         DEALLOCATE (VECTF1)
         DEALLOCATE (VECTF2)
         DEALLOCATE (VECTF3)
         DEALLOCATE (TABnoeud1)
         DEALLOCATE (TABnoeud2)
         DEALLOCATE (TABnoeud3)
         GOTO 777
       endif

c si le nombre d'inconuues vaut zero on affecte a
c la maille grossiere la moyenne arithmetique.
c (une meilleure solution serait le raffinement de maillage)


c      write(*,*)'debut 2D'

      if ((nti1.eq.0).or.(nti2.eq.0).or.(nti3.eq.0)) then
         err=0
         call MODULE_2D_NC_c(ntn,nte,err,RESULTATS_MC,nbgros,eps,ig,
     @                     kmax,nti,nnf,nti1,nti2,nti3,MaMO,
     @                     TABele,PETRO,COORD_POS)
         DEALLOCATE (VECTI1)
         DEALLOCATE (VECTI2)
         DEALLOCATE (VECTI3)
         DEALLOCATE (VECTF1)
         DEALLOCATE (VECTF2)
         DEALLOCATE (VECTF3)
         DEALLOCATE (TABnoeud1)
         DEALLOCATE (TABnoeud2)
         DEALLOCATE (TABnoeud3)
         GOTO 777
       endif


c on remplie VECTI des noeuds interieur et VECTF des noeuds frontaliers
c attention les VECTI et les VECTF doivent etre ranges dans l''ordre 
c croissant des numeros
    
      call REMPLIR1_C(VECTI1,VECTI2,VECTI3,VECTF1,VECTF2,VECTF3,
     @               TABnoeud1,TABnoeud2,TABnoeud3,ntn,COORD_POS)


c      write(20,*)'ATTENTION les VECTI et les VECTF doivent etre '
c      write(20,*)'ranges dans l''ordre croissant'
c      write(20,*)'VECTF1'
c      write(20,*)(VECTF1(i),i=1,nnf1)
c      write(20,*)
c      write(20,*)'VECTI1'
c      write(20,*)(VECTI1(i),i=1,nti1)
c      write(20,*)
c      write(20,*)'VECTF2'
c      write(20,*)(VECTF2(i),i=1,nnf2)
c      write(20,*)
c      write(20,*)'VECTI2'
c      write(20,*)(VECTI2(i),i=1,nti2)
c      write(20,*)
c      write(20,*)'VECTF3'
c      write(20,*)(VECTF3(i),i=1,nnf3)
c      write(20,*)
c      write(20,*)'VECTI3'
c      write(20,*)(VECTI3(i),i=1,nti3)
c      write(20,*)

c allocation dynamique de memoire de tableaux 
c Attention il faut que LIGNE1(i,1) est ete initialise a zero
c avant la boucle sur les mailles grossiere.


       i=1
       do while (i.le.nbtam)
         if ((LIGNE1(i,1).eq.ntn).and.(LIGNE1(i,2).eq.nte).and.
     @      (LIGNE1(i,3).eq.nti1).and.(LIGNE1(i,4).eq.nti2).and.
     @      (LIGNE1(i,5).eq.nti3).and.(LIGNE1(i,6).eq.nnf1).and.
     @      (LIGNE1(i,7).eq.nnf2).and.(LIGNE1(i,8).eq.nnf3)) then
             ALLOCATE (ia1(LIGNE1(i,3)+1))
             ALLOCATE (ia2(LIGNE1(i,4)+1))
             ALLOCATE (ia3(LIGNE1(i,5)+1))
             ALLOCATE (ic1(LIGNE1(i,6)+1))
             ALLOCATE (ib1(LIGNE1(i,6)+1))
             ALLOCATE (ic2(LIGNE1(i,7)+1))
             ALLOCATE (ib2(LIGNE1(i,7)+1))
             ALLOCATE (ic3(LIGNE1(i,8)+1))
             ALLOCATE (ib3(LIGNE1(i,8)+1))
             ALLOCATE (cc1(LIGNE1(i,15)))
             ALLOCATE (jc1(LIGNE1(i,15)))
             ALLOCATE (cc2(LIGNE1(i,16)))
             ALLOCATE (jc2(LIGNE1(i,16)))
             ALLOCATE (cc3(LIGNE1(i,17)))
             ALLOCATE (jc3(LIGNE1(i,17)))
             nelemA1=LIGNE1(i,9)
             nelemA2=LIGNE1(i,10)
             nelemA3=LIGNE1(i,11)
             nelemB1=LIGNE1(i,12)
             nelemB2=LIGNE1(i,13)
             nelemB3=LIGNE1(i,14)
             nelemC1=LIGNE1(i,15)
             nelemC2=LIGNE1(i,16)
             nelemC3=LIGNE1(i,17)
             do j=1,nti1+1
               ia1(j)=LIGNEia1(i,j)        
             enddo
             do j=1,nti2+1
                ia2(j)=LIGNEia2(i,j)            
             enddo
             do j=1,nti3+1
                ia3(j)=LIGNEia3(i,j)
             enddo
             do j=1,nnf1+1
                ib1(j)=LIGNEib1(i,j)
                ic1(j)=LIGNEic1(i,j)
             enddo
             do j=1,nnf2+1
                ib2(j)=LIGNEib2(i,j)          
                ic2(j)=LIGNEic2(i,j)          
             enddo
             do j=1,nnf3+1
                ib3(j)=LIGNEib3(i,j)       
                ic3(j)=LIGNEic3(i,j)          
             enddo
             do j=1,nelemC1
                jc1(j)=LIGNEjc1(i,j)        
                cc1(j)=LIGNEcc1(i,j)         
             enddo
             do j=1,nelemC2
                jc2(j)=LIGNEjc2(i,j)         
                cc2(j)=LIGNEcc2(i,j)        
             enddo
             do j=1,nelemC3
                jc3(j)=LIGNEjc3(i,j)        
                cc3(j)=LIGNEcc3(i,j)           
             enddo
             GOTO 666
             else
               i=i+1
         endif
       enddo

      i=1
      do while ((LIGNE1(i,1).ne.0).and.(i.le.nbtam)) 
             i=i+1
      enddo
      if (i.le.nbtam) then
                         igk=i
                      else
                         igk=itag
                         itag=itag+1
                         if (itag.gt.nbtam) then
                             itag=1
                         endif
      endif                                   

      ALLOCATE(MATA1(nti1,lb))
      ALLOCATE(MATA2(nti2,lb))
      ALLOCATE(MATA3(nti3,lb))
      ALLOCATE(MATB1(nnf1,lb))
      ALLOCATE(MATB2(nnf2,lb))
      ALLOCATE(MATB3(nnf3,lb))
      ALLOCATE(MATC1(nnf1,lb))
      ALLOCATE(MATC2(nnf2,lb))
      ALLOCATE(MATC3(nnf3,lb))
      ALLOCATE (ia1(nti1+1))
      ALLOCATE (ia2(nti2+1))
      ALLOCATE (ia3(nti3+1))

      call PRELIMINAIRE21_C(VECTF1,VECTF2,VECTF3,VECTI1,VECTI2,VECTI3,
     @     TABele,nnf1,nnf2,nnf3,nti1,nti2,nti3,nte,ia1,ia2,ia3,
     @     MATA1,MATA2,MATA3,MATB1,MATB2,MATB3,MATC1,MATC2,MATC3,
     @ ord_gr1,ord_gr2,ord_gr3,lb,TABnoeud1,TABnoeud2,TABnoeud3,ntn)

      write(20,*)'je passe prelimi'

c on rend la memoire du tableau au systeme

      DEALLOCATE(MATA1)
      DEALLOCATE(MATA2)
      DEALLOCATE(MATA3)

c allocation dynamique de memoire de tableaux

      ALLOCATE (VECT11(ord_gr1))
      ALLOCATE (ic1(nnf1+1))
      ALLOCATE (ib1(nnf1+1))
      ALLOCATE (VECT12(ord_gr2))
      ALLOCATE (ic2(nnf2+1))
      ALLOCATE (ib2(nnf2+1))
      ALLOCATE (VECT13(ord_gr3))
      ALLOCATE (ic3(nnf3+1))
      ALLOCATE (ib3(nnf3+1))

      call PRELIMINAIRE22_C(VECTF1,VECTF2,VECTF3,VECTI1,VECTI2,
     @           VECTI3,TABele,nnf1,nnf2,nnf3,nti1,nti2,nti3,nte,
     @           ic1,ic2,ic3,nelemC1,nelemC2,nelemC3,VECT11,VECT12,
     @           VECT13,ib1,ib2,ib3,nelemB1,nelemB2,nelemB3,
     @           ia1,ia2,ia3,nelemA1,nelemA2,nelemA3,
     @           MATB1,MATB2,MATB3,MATC1,MATC2,MATC3)


c on rend la memoire des tableaux au systeme

      DEALLOCATE(MATB1)
      DEALLOCATE(MATB2)
      DEALLOCATE(MATB3)
      DEALLOCATE(MATC1)
      DEALLOCATE(MATC2)
      DEALLOCATE(MATC3)


c allocation dynamique de memoire des tableaux cc,jc

      ALLOCATE (cc1(nelemC1))
      ALLOCATE (jc1(nelemC1))
      ALLOCATE (cc2(nelemC2))
      ALLOCATE (jc2(nelemC2))
      ALLOCATE (cc3(nelemC3))
      ALLOCATE (jc3(nelemC3))

c calcul du tableau ic et initialisation du tableau cc

      call CAL_JC_C(VECT11,VECT12,VECT13,jc1,jc2,jc3,
     @             nelemC1,nelemC2,nelemC3,ntn,cc1,cc2,cc3)

c on rend la memoire du tableau VECT1 au systeme

      DEALLOCATE(VECT11)
      DEALLOCATE(VECT12)
      DEALLOCATE(VECT13)


      max=MAX0(ntn,nte,nti1,nti2,nti3,nnf1,nnf2,nnf3,nelemA1,nelemA2,
     @       nelemA3,nelemB1,nelemB2,nelemB3,nelemC1,nelemC2,nelemC3)

      if (max.le.taille) then
         LIGNE1(igk,1)=ntn
         LIGNE1(igk,2)=nte
         LIGNE1(igk,3)=nti1
         LIGNE1(igk,4)=nti2
         LIGNE1(igk,5)=nti3
         LIGNE1(igk,6)=nnf1
         LIGNE1(igk,7)=nnf2
         LIGNE1(igk,8)=nnf3
         LIGNE1(igk,9)=nelemA1
         LIGNE1(igk,10)=nelemA2
         LIGNE1(igk,11)=nelemA3
         LIGNE1(igk,12)=nelemB1
         LIGNE1(igk,13)=nelemB2
         LIGNE1(igk,14)=nelemB3
         LIGNE1(igk,15)=nelemC1
         LIGNE1(igk,16)=nelemC2
         LIGNE1(igk,17)=nelemC3
         do j=1,nti1+1
            LIGNEia1(igk,j)=ia1(j)
         enddo
         do j=1,nti2+1
            LIGNEia2(igk,j)=ia2(j)
         enddo
         do j=1,nti3+1
            LIGNEia3(igk,j)=ia3(j)
         enddo
         do j=1,nnf1+1
            LIGNEib1(igk,j)=ib1(j)
            LIGNEic1(igk,j)=ic1(j)
         enddo
         do j=1,nnf2+1
            LIGNEib2(igk,j)=ib2(j)
            LIGNEic2(igk,j)=ic2(j)
         enddo
         do j=1,nnf3+1
            LIGNEib3(igk,j)=ib3(j)
            LIGNEic3(igk,j)=ic3(j)
         enddo
         do j=1,nelemC1
            LIGNEjc1(igk,j)=jc1(j)
            LIGNEcc1(igk,j)=cc1(j)
         enddo
         do j=1,nelemC2
            LIGNEjc2(igk,j)=jc2(j)
            LIGNEcc2(igk,j)=cc2(j)
         enddo
         do j=1,nelemC3
            LIGNEjc3(igk,j)=jc3(j)
            LIGNEcc3(igk,j)=cc3(j)
         enddo
        else
         write(*,*)'augementer la valeur de taille pour'
         write(*,*)'aller plus vite'
      endif

666   CONTINUE


c allocation dynamique de memoire des tableaux aa,bb,ja,jb,al,SMinter
      
      ALLOCATE (aa1(nelemA1))
      ALLOCATE (al1(nelemA1))
      ALLOCATE (ja1(nelemA1)) 
      ALLOCATE (bb1(nelemB1))
      ALLOCATE (jb1(nelemB1))
      ALLOCATE (SMinter1(nti1))

      ALLOCATE (aa2(nelemA2))
      ALLOCATE (al2(nelemA2))
      ALLOCATE (ja2(nelemA2))
      ALLOCATE (bb2(nelemB2))
      ALLOCATE (jb2(nelemB2))
      ALLOCATE (SMinter2(nti2))

      ALLOCATE (aa3(nelemA3))
      ALLOCATE (al3(nelemA3))
      ALLOCATE (ja3(nelemA3))
      ALLOCATE (bb3(nelemB3))
      ALLOCATE (jb3(nelemB3))
      ALLOCATE (SMinter3(nti3))


c      write(*,*)'CALCUL DES CONTRIBUTIONS ET ASSEMBLAGE'
c      write(20,*)'CALCUL DES CONTRIBUTIONS ET ASSEMBLAGE'            

c initialisation de tous les tableaux a zero

      call MISE_A_ZERO_C(bb1,bb2,bb3,jb1,jb2,jb3,aa1,aa2,aa3,
     @      ja1,ja2,ja3,K,SMinter1,SMinter2,SMinter3,nti1,nti2,nti3,
     @      nelemA1,nelemA2,nelemA3,nelemB1,nelemB2,nelemB3,
     @      poroh1,MOY1,poroh2,MOY2,poroh3,MOY3,volume1,volume2,volume3)

c on boucle sur les elements
c on construit la matrice du systeme lineaire A 


      do chele=1,nte

c         write(20,*)'chele',chele
c on affecte la permeabilite et la porosite de l'element considere

         K(1,1)=PETRO(chele,1)
         K(2,2)=PETRO(chele,2)              
         K(3,3)=PETRO(chele,3)                
         poro=PETRO(chele,4)               

c on donne les informations de l'element

         do j=2,9
            INDICE1(j)=TABnoeud1(TABele(chele,j),5)
            INDICE2(j)=TABnoeud2(TABele(chele,j),5)
            INDICE3(j)=TABnoeud3(TABele(chele,j),5)
            if (TABnoeud1(TABele(chele,j),4).eq.0) then
                elementbis1(j)=.false.
                                               else
                elementbis1(j)=.true. 
            endif
            if (TABnoeud2(TABele(chele,j),4).eq.0) then
                elementbis2(j)=.false.
                                               else
                elementbis2(j)=.true. 
            endif
            if (TABnoeud3(TABele(chele,j),4).eq.0) then
                elementbis3(j)=.false.
                                               else
                elementbis3(j)=.true. 
            endif
         enddo
         do j=1,3
            N1(j+1)=TABnoeud1(TABele(chele,2),j)
            N2(j+1)=TABnoeud1(TABele(chele,3),j)
            N3(j+1)=TABnoeud1(TABele(chele,4),j)
            N4(j+1)=TABnoeud1(TABele(chele,5),j)
            N5(j+1)=TABnoeud1(TABele(chele,6),j)
            N6(j+1)=TABnoeud1(TABele(chele,7),j)
            N7(j+1)=TABnoeud1(TABele(chele,8),j)
            N8(j+1)=TABnoeud1(TABele(chele,9),j)
         enddo


c calcul de la contribution et assemblage pour un hexaedre

        call CALCULQ1_C(ELEMENTBIS1,INDICE1,bb1,ib1,jb1,aa1,ia1,ja1,
     @        SMinter1,N1,N2,N3,N4,N5,N6,N7,N8,K,cc1,ic1,jc1,volume1,
     @        poro,poroh1,MOY1)


        call CALCULQ1_C(ELEMENTBIS2,INDICE2,bb2,ib2,jb2,aa2,ia2,ja2,
     @        SMinter2,N1,N2,N3,N4,N5,N6,N7,N8,K,cc2,ic2,jc2,volume2,
     @        poro,poroh2,MOY2)


        call CALCULQ1_C(ELEMENTBIS3,INDICE3,bb3,ib3,jb3,aa3,ia3,ja3,
     @        SMinter3,N1,N2,N3,N4,N5,N6,N7,N8,K,cc3,ic3,jc3,volume3,
     @        poro,poroh3,MOY3)

c        write(20,*)'volume',volume1,volume2,volume3

      enddo


c      write(*,*)'CONSTITUTION DES 3 SYSTEMES LINEAIRES ET RESOLUTION'

c      do i=1,nelemC1
c         write(20,*)i,'cc1=',cc1(i),'    jc1=',jc1(i)
c      enddo
c      do i=1,nelemC2
c         write(20,*)i,'cc2=',cc2(i),'    jc2=',jc2(i)
c      enddo
c      do i=1,nelemC3
c         write(20,*)i,'cc3=',cc3(i),'    jc3=',jc3(i)
c      enddo

c on tri le tableau aa
                 
      do i=1,nti1
        call TRI_C(ja1(ia1(i)),aa1(ia1(i)),ia1(i+1)-ia1(i))
      enddo

      do i=1,nti2
        call TRI_C(ja2(ia2(i)),aa2(ia2(i)),ia2(i+1)-ia2(i))
      enddo

      do i=1,nti3
        call TRI_C(ja3(ia3(i)),aa3(ia3(i)),ia3(i+1)-ia3(i))
      enddo


c on tri le tableau bb

      do i=1,nnf1
        call TRI_C(jb1(ib1(i)),bb1(ib1(i)),ib1(i+1)-ib1(i))
      enddo

      do i=1,nnf2
        call TRI_C(jb2(ib2(i)),bb2(ib2(i)),ib2(i+1)-ib2(i))
      enddo

      do i=1,nnf3
        call TRI_C(jb3(ib3(i)),bb3(ib3(i)),ib3(i+1)-ib3(i))
      enddo

c      do i=1,nelemB1
c         write(20,*)i,'bb1=',bb1(i),'    jb1=',jb1(i)
c      enddo
c      do i=1,nelemB2
c         write(20,*)i,'bb2=',bb2(i),'    jb2=',jb2(i)
c      enddo
c      do i=1,nelemB3
c         write(20,*)i,'bb3=',bb3(i),'    jb3=',jb3(i)
c      enddo

c      do i=1,nelemA1
c         write(20,*)i,'aa1=',aa1(i),'    ja1=',ja1(i)
c      enddo
c      do i=1,nelemA2
c         write(20,*)i,'aa2=',aa2(i),'    ja2=',ja2(i)
c      enddo
c      do i=1,nelemA3
c         write(20,*)i,'aa3=',aa3(i),'    ja3=',ja3(i)
c      enddo

c  calcul de la factorise de choleski incomplete

       call ICholeski_c(nti1,aa1,ia1,ja1,al1)
       call ICholeski_c(nti2,aa2,ia2,ja2,al2)
       call ICholeski_c(nti3,aa3,ia3,ja3,al3)

c      write(20,*)'factorise de choleski'
c      do i=1,nelemA1
c         write(20,*)'al1=',al1(i)
c      enddo

c on rend la memoire du tableau TABele au systeme


c allocation dynamique de memoire des tableaux SM,CONDB1,CONDB2,
c CONDB3,X1,X2,X3

      ALLOCATE (SM1(nti1))
      ALLOCATE (SM2(nti2))
      ALLOCATE (SM3(nti3))
      ALLOCATE (CONDB1(nnf1))
      ALLOCATE (CONDB2(nnf2))
      ALLOCATE (CONDB3(nnf3))
      ALLOCATE (X1(nti1))
      ALLOCATE (X2(nti2))
      ALLOCATE (X3(nti3))

c on initialise a zero le vecteur X1 et on affecte le vecteur SMinter au
c vecteur SM
      
      do i=1,nti1
         SM1(i)=SMinter1(i)
c         write(20,*)'SMinter1',SMinter1(i)
         X1(i)=0.d0
      enddo

c on affecte les conditions aux limites du probleme local 1 au vecteur SM

      call SECOND_MEMB_C(cc1,ic1,jc1,CONDB1,SM1,nnf1,ntn,
     @                 TABnoeud1,nti1,VECTF1,1) 

      DEALLOCATE (VECTI1)
      DEALLOCATE (VECTF1)
      DEALLOCATE (SMinter1)

      write(20,*)'SM1'
      do i=1,nti1
c         write(20,*)SM1(i)
      enddo


c allocation dynamique de memoire des tableaux gg,h,cg

      ALLOCATE (gg(nti1))
      ALLOCATE (h(nti1))
      ALLOCATE (cg(nti1))

c on resout le systeme lineaire relatif au probleme local 1
      
      call GradC_C(nti1,aa1,ia1,ja1,al1,SM1,X1,gg,h,cg,kmax,eps)
      DEALLOCATE (gg)
      DEALLOCATE (h)
      DEALLOCATE (cg)
      DEALLOCATE (al1)
      DEALLOCATE (SM1)
c      write(20,*)
      write(20,*)'1 ere solution'
      call ecrire_c(X1,nti1)
       
c on initialise a zero le vecteur X2 et on affecte le vecteur SMinter au
c vecteur SM
      
      do i=1,nti2
c         write(20,*)SM2(i)
         SM2(i)=SMinter2(i)
         X2(i)=0.d0
      enddo

c on affecte les conditions aux limites du probleme local 2 au vecteur SM

      call SECOND_MEMB_C(cc2,ic2,jc2,CONDB2,SM2,nnf2,ntn,
     @                 TABnoeud2,nti2,VECTF2,2) 

      DEALLOCATE (VECTI2)
      DEALLOCATE (VECTF2)
      DEALLOCATE (SMinter2)

c      write(20,*)
c      do i=1,nti2
c         write(20,*)SM2(i)
c      enddo

      ALLOCATE (gg(nti2))
      ALLOCATE (h(nti2))
      ALLOCATE (cg(nti2))

c on resout le systeme lineaire relatif au probleme local 2
      
      call GradC_C(nti2,aa2,ia2,ja2,al2,SM2,X2,gg,h,cg,kmax,eps)
c      write(20,*)
      write(20,*)'2 eme solution'
      call ecrire_c(X2,nti2)

      DEALLOCATE (gg)
      DEALLOCATE (h)
      DEALLOCATE (cg)
      DEALLOCATE (al2)
      DEALLOCATE (SM2)

c on initialise a zero le vecteur X3 et on affecte le vecteur SMinter au
c vecteur SM

      do i=1,nti3
         SM3(i)=SMinter3(i)
         X3(i)=0.d0
      enddo

      DEALLOCATE (SMinter3)

c on affecte les conditions aux limites du probleme local 3 au vecteur SM

      call SECOND_MEMB_C(cc3,ic3,jc3,CONDB3,SM3,nnf3,ntn,
     @                 TABnoeud3,nti3,VECTF3,3)

      ALLOCATE (gg(nti3))
      ALLOCATE (h(nti3))
      ALLOCATE (cg(nti3))


c on resout le systeme lineaire relatif au probleme local 3
     
      call GradC_C(nti3,aa3,ia3,ja3,al3,SM3,X3,gg,h,cg,kmax,eps)
c      write(20,*)
      write(20,*)'3 eme solution'
      call ecrire_c(X3,nti3)

c on rend la memoire des tableaux au systeme 

      DEALLOCATE (gg)
      DEALLOCATE (h)
      DEALLOCATE (cg)
      DEALLOCATE (VECTI3)
      DEALLOCATE (VECTF3)
      DEALLOCATE (al3)
      DEALLOCATE (SM3)
      DEALLOCATE (TABnoeud1)
      DEALLOCATE (TABnoeud2)
      DEALLOCATE (TABnoeud3)

c      write(*,*)'CALCUL DU TENSEUR HOMOGENEISE'

c on calcule la permeabilite homogeneise

c       write(20,*)'avant'
c       write(20,*)'volume',volume1

      call PERMEAEQUI_C(aa1,aa2,aa3,ia1,ia2,ia3,ja1,ja2,ja3,X1,X2,X3,
     @           nti1,nti2,nti3,nnf1,nnf2,nnf3,volume1,CONDB1,CONDB2,
     @        CONDB3,bb1,bb2,bb3,ib1,ib2,ib3,jb1,jb2,jb3,cc1,cc2,cc3,
     @    ic1,ic2,ic3,jc1,jc2,jc3,poroh1,MOY1,RESULTATS_MC,ig,nbgros)

c on rend la memoire des tableau au systeme
     
      DEALLOCATE (ia1)
      DEALLOCATE (ib1)
      DEALLOCATE (ic1)
      DEALLOCATE (ja1)
      DEALLOCATE (jb1)
      DEALLOCATE (jc1)
      DEALLOCATE (aa1)
      DEALLOCATE (bb1)
      DEALLOCATE (cc1)

      DEALLOCATE (ia2)
      DEALLOCATE (ib2)
      DEALLOCATE (ic2)
      DEALLOCATE (ja2)
      DEALLOCATE (jb2)
      DEALLOCATE (jc2)
      DEALLOCATE (aa2)
      DEALLOCATE (bb2)
      DEALLOCATE (cc2)

      DEALLOCATE (ia3)
      DEALLOCATE (ib3)
      DEALLOCATE (ic3)
      DEALLOCATE (ja3)
      DEALLOCATE (jb3)
      DEALLOCATE (jc3)
      DEALLOCATE (aa3)
      DEALLOCATE (bb3)
      DEALLOCATE (cc3)

      DEALLOCATE (CONDB1)
      DEALLOCATE (CONDB2)
      DEALLOCATE (CONDB3)
      DEALLOCATE (X1)
      DEALLOCATE (X2)
      DEALLOCATE (X3)


c      write(*,*)'nombre d''inconnues du systeme1: ',nti1
c      write(*,*)'nombre d''inconnues du systeme2: ',nti2
c      write(*,*)'nombre d''inconnues du systeme3: ',nti3
c      write(*,*)
c      write(*,*)'fin de l''application'


777   CONTINUE   ! a conserver absolument

c fermeture des fichiers

c      close(11)
      close(16)

      RETURN
      end





 
